	
	function BrowsrHistory(name, fn, params, sindex, image, img_type) {
		/* Defines the items to be stored in history */
		this.name = name;
		this.fn = fn;
		this.params = params;
		this.sindex = sindex;
		this.image = image;
		this.img_type = img_type;
	}
	
	function Browsr() {
		this.screen = "";
		this.onion = false;
		this.onion_cancel_ok = true;
		this.mode = MODE_TAB;
		this.menus = [];
		this.frame = FRAME_WHITE;
		this.bg = BG_CUSTOM;
		this.screens = [];
		this.history = [];
	}
	
	Browsr.prototype.addEvent = function(name, fn, params, sindex, image, img_type) {
		this.history.push(new BrowsrHistory(name, fn, params, sindex, image, img_type));
		
		if(image)
		{
			if(img_type == 'icon')
			{
				$('header_icon_bg').className = 'header_icon';
				$('header_icon').src = image;
			}
			else
			{
				$('header_icon_bg').className = 'header_pframe';
				$('header_icon').src = image;
			}
		}
		else
		{
			if(img_type == 'icon')
			{
				$('header_icon_bg').className = 'header_icon';
				$('header_icon').src = './images/tmp_icon_big.png';
			}
			else
			{
				$('header_icon_bg').className = 'header_pframe';
				$('header_icon').src = './images/tmp_icon.png';
			}
		}
		
		if( this.history.length > 1 )
		{
			if(isNokia)
				menu.setRightSoftkeyLabel('Back', goBack);
		}
	}
	
	Browsr.prototype.lastEvent = function() {
		var lastevent = this.history.pop();
		
		if(this.history.length == 1)
		{
			if(isNokia)
				menu.setRightSoftkeyLabel('', null);
		}
			
		return lastevent;
	}
	
	Browsr.prototype.clear = function() {
		this.history.splice(0, this.history.length);
	}
	
	function goBack() {
		curevent = browsr.lastEvent();
		lastevent = browsr.lastEvent();
		
		if(lastevent && curevent)
		{
			Helper.destroyCurrentScreen();
			
			browsr.addEvent(lastevent.name, lastevent.fn, lastevent.params, lastevent.sindex, lastevent.image, lastevent.img_type);
			
			/* copy the params with sindex and pass it to the calling function */
			lastevent.params["sindex"] = curevent.sindex;
			
			/* clear the onion skin if any */
			browsr.onion = false;
			browsr.onion_cancel_ok = true;
			lastevent.fn(lastevent.params);
		}
		
		return;
	}
	
	
	
	
	
	
	
	
