	/* Defines a browsr menu object */
	function BrowsrMenu(name, id) {
		this.name = name;
		this.id = id;
	}
	
	/* TODO: Change the name */
	
	function OptionItem(id, name, selected, unselected, callback) {
		this.id         = id;
		this.name       = name;
		this.selected   = selected;
		this.unselected = unselected;
		this.callback   = callback;
		this.subitems   = [];
	}
	
	function OptionSubItem(id, name, selected, unselected, callback, visible, select_bydefaut, parent) {
		if(parent instanceof OptionItem)
		{
			this.id = id;
			this.name = name;
			this.selected = selected;
			this.unselected = unselected;
			this.callback = callback;
			this.visible = visible;
			this.select_bydefaut = select_bydefaut;
			this.parent = parent;
			this.parent.subitems.push(this);
		}
	}
	
	/* Ideally shud go somewhere else!!! */
	
	var MENU_WHERE_AM_I      = new OptionItem(1001,
											  'Where am I?',
											  './images/where_am_i_s.png',
											  './images/where_am_i_us.png',
											  cbWhereAmI);
											  
	var MENU_GOT_LOST        = new OptionItem(1002,
											  'Got Lost!',
											  './images/got_lost_s.png',
											  './images/got_lost_us.png',
											  cbGotLost);
											  
	var MENU_CLEAR_HISTORY   = new OptionItem(1003,
											  'Clear History',
											  './images/clear_history_s.png',
											  './images/clear_history_us.png',
											  cbClearHistory);
											  
	var MENU_REFRESH         = new OptionItem(1004,
											  'Refresh',
											  './images/refresh_s.png',
											  './images/refresh_us.png',
											  cbRefresh);
											  
	var MENU_ADD_TO_BMARKS   = new OptionItem(1005,
											  'Add to Bookmarks',
											  './images/add_to_bmarks_s.png',
											  './images/add_to_bmarks_us.png',
											  null);
											  
	var MENU_REMOVE_FROM_BMARKS = new OptionItem(1006,
											  'Remove from Bookmarks',
											  './images/remove_from_bmarks_s.png',
											  './images/remove_from_bmarks_us.png',
											  null);
											  
	var MENU_SHOW_IN_BROWSER    = new OptionItem(1007,
											  'Show in Browser',
											  './images/show_in_browser_s.png',
											  './images/show_in_browser_us.png',
											  cbShowInBrowser);
											  
	var MENU_SETTINGS        = new OptionItem(1008,
											  'Settings',
											  './images/settings_s.png',
											  './images/settings_us.png',
											  null);
											  
	var MENU_SWITCH_TO_TABS     = new OptionItem(1009,
											  'Switch To Tabs',
											  './images/switch_to_tabs_s.png',
											  './images/switch_to_tabs_us.png',
											  cbSwitchToTabs);
											  
	var MENU_SWITCH_TO_LIST     = new OptionItem(1010,
											  'Switch To List',
											  './images/switch_to_list_s.png',
											  './images/switch_to_list_us.png',
											  cbSwitchToList);
											  
	var MENU_FRAME              = new OptionItem(1011,
											  'Frame',
											  './images/frame_s.png',
											  './images/frame_us.png',
											  cbShowSubItems);
											  
	var MENU_FRAME_NO           = new OptionSubItem(2001,
												 'No Frame',
												 './images/frame_no_s.png',
												 './images/frame_no_us.png',
												 cbFrameNo,
												 true,
												 false,
												 MENU_FRAME);
											  
	var MENU_FRAME_WHITE        = new OptionSubItem(2002,
												 'White Frame',
												 './images/frame_white_s.png',
												 './images/frame_white_us.png',
												 cbFrameWhite,
												 true,
												 false,
												 MENU_FRAME);
												 
	var MENU_FRAME_BLACK        = new OptionSubItem(2003,
												 'Black Frame',
												 './images/frame_black_s.png',
												 './images/frame_black_us.png',
												 cbFrameBlack,
												 true,
												 false,
												 MENU_FRAME);
												 
	var MENU_FRAME_POLAROID      = new OptionSubItem(2004,
												 'Polaroid Frame',
												 './images/frame_polaroid_s.png',
												 './images/frame_polaroid_us.png',
												 cbFramePolaroid,
												 true,
												 false,
												 MENU_FRAME);
												 
	var MENU_BACKGROUND          = new OptionItem(1012,
												  'Settings',
											      './images/background_s.png',
											      './images/background_us.png',
											      cbShowSubItems);
												  
	var MENU_BG_NO           = new OptionSubItem(3001,
												 'No Background',
												 './images/frame_no_s.png',
												 './images/frame_no_us.png',
												 cbBgNo,
												 true,
												 false,
												 MENU_BACKGROUND);
											  
	var MENU_BG_WHITE        = new OptionSubItem(3002,
												 'White Background',
												 './images/frame_white_s.png',
												 './images/frame_white_us.png',
												 cbBgWhite,
												 true,
												 false,
												 MENU_BACKGROUND);
												 
	var MENU_BG_BLACK       = new OptionSubItem(3003,
												 'Black Background',
												 './images/frame_black_s.png',
												 './images/frame_black_us.png',
												 cbBgBlack,
												 true,
												 false,
												 MENU_BACKGROUND);
												 
	var MENU_BG_CUSTOM       = new OptionSubItem(3004,
												 'Custom Background',
												 './images/bg_custom_s.png',
												 './images/bg_custom_us.png',
												 cbBgCustom,
												 true,
												 true,
												 MENU_BACKGROUND);
	
	
	/* TODO: Useless Function : REMOVE THIS */
	/*
	function getMenuById(id) {
		if(browsr && browsr.menus)
		{
			var i=0;
			for(i=0; i < browsr.menus.length; i++)
			{
				if(browsr.menus[i].id == id)
					return browsr.menus[i];
			}
		}
		return null;
	}
	*/
	
	/* Load menus */
	function loadMenu() {
	
		if(isNokia)
		{
			var m_where_am_i = new MenuItem(MENU_WHERE_AM_I.name, MENU_WHERE_AM_I.id);
			var m_got_lost = new MenuItem(MENU_GOT_LOST.name, MENU_GOT_LOST.id);
			var m_clear_history = new MenuItem(MENU_CLEAR_HISTORY.name, MENU_CLEAR_HISTORY.id);
			var m_refresh = new MenuItem(MENU_REFRESH.name, MENU_REFRESH.id);
			var m_add_to_bmarks = new MenuItem(MENU_ADD_TO_BMARKS.name, MENU_ADD_TO_BMARKS.id);
			var m_remove_from_bmarks = new MenuItem(MENU_REMOVE_FROM_BMARKS.name, MENU_REMOVE_FROM_BMARKS.id);
			var m_show_in_browser = new MenuItem(MENU_SHOW_IN_BROWSER.name, MENU_SHOW_IN_BROWSER.id);
			var m_my_settings = new MenuItem(MENU_SETTINGS.name, MENU_SETTINGS.id);
			var m_switch_to_tabs = new MenuItem(MENU_SWITCH_TO_TABS.name, MENU_SWITCH_TO_TABS.id);
			var m_switch_to_list = new MenuItem(MENU_SWITCH_TO_LIST.name, MENU_SWITCH_TO_LIST.id);

			m_where_am_i.onSelect = cbWhereAmI;
			m_got_lost.onSelect = cbGotLost;
			m_clear_history.onSelect = cbClearHistory;
			m_refresh.onSelect = cbRefresh;
			m_add_to_bmarks.onSelect = cbAddToBookmarks;
			m_remove_from_bmarks.onSelect = cbRemoveFromBookmarks;
			m_show_in_browser.onSelect = cbShowInBrowser;
			m_my_settings.onSelect = cbSettings;
			m_switch_to_tabs.onSelect = cbSwitchToTabs;
			m_switch_to_list.onSelect = cbSwitchToList;
			
			/* Appends */
			window.menu.append(m_where_am_i);
			window.menu.append(m_got_lost);
			window.menu.append(m_clear_history);
			window.menu.append(m_refresh);
			window.menu.append(m_add_to_bmarks);
			window.menu.append(m_remove_from_bmarks);
			window.menu.append(m_show_in_browser);
			window.menu.append(m_my_settings);
			window.menu.append(m_switch_to_tabs);
			window.menu.append(m_switch_to_list);
		}
		else
		{
			
			/* Add to the toolbar */
			if(toolbar)
			{
				toolbar.addArray([MENU_GOT_LOST,
								  MENU_SWITCH_TO_TABS, 
								  MENU_SWITCH_TO_LIST,
								  MENU_WHERE_AM_I,
								  MENU_CLEAR_HISTORY,
								  MENU_SHOW_IN_BROWSER,
								  MENU_REFRESH,
								  MENU_SETTINGS,
								  MENU_FRAME,
								  MENU_BACKGROUND]);
			}
		}
	}
	
	/* Definitions of menu callback functions */
	
	function cbWhereAmI() {
		/* Callback for where am i */
		
		/* destroy current screen */
		Helper.destroyCurrentScreen();
		
		var params = [];
		browsr.addEvent('Where Am I?', whereami.show, params, 0, whereAmIImage, 'icon');
		whereami.show(params);
		toolbar.deselectById(MENU_WHERE_AM_I.id);
	}
	
	function cbGotLost() {
		browsr.history.splice(0, browsr.history.length);
		
		/* destroy current screen */
		Helper.destroyCurrentScreen();
		
		var params = [];
		params["user_nsid"] = user.user_nsid;
		
		browsr.addEvent('Home', home.show, params, 0);
		home.show(params);
		params = null;
		
		toolbar.deselectById(MENU_GOT_LOST.id);
	}
	
	function cbClearHistory() {
		browsr.history.splice(0, (browsr.history.length - 1));
		
		if(isNokia)
			menu.setRightSoftkeyLabel('', null);
			
		toolbar.deselectById(MENU_CLEAR_HISTORY.id);
	}
	
	function cbRefresh() {
		if(browsr)
		{
			browsr.screens[browsr.screen].refresh();
			toolbar.deselectById(MENU_REFRESH.id);
		}
	}
	
	function cbAddToBookmarks() {
		switch(browsr.screen)
		{
			case SCREEN_PHOTOSTREAM:
				photostream.addToBookmarks();
				break;
				
			case SCREEN_PHOTO:
				photo.addToBookmarks();
				break;
				
			case SCREEN_SPHOTO:
				sphoto.addToBookmarks();
				break;
				
			case SCREEN_CONTACTS:
				contacts.addToBookmarks();
				break;
				
			case SCREEN_CONTACT:
				contact.addToBookmarks();
				break;
				
			case SCREEN_SETS:
				sets.addToBookmarks();
				break;
				
			case SCREEN_SET:
				set.addToBookmarks();
				break;
		}
	}
	
	function cbRemoveFromBookmarks() {
		switch(browsr.screen)
		{
			case SCREEN_PHOTOSTREAM:
				photostream.removeFromBookmarks();
				break;
				
			case SCREEN_PHOTO:
				photo.removeFromBookmarks();
				break;
				
			case SCREEN_SPHOTO:
				sphoto.removeFromBookmarks();
				break;
				
			case SCREEN_CONTACTS:
				contacts.removeFromBookmarks();
				break;
				
			case SCREEN_CONTACT:
				contact.removeFromBookmarks();
				break;
				
			case SCREEN_SETS:
				sets.removeFromBookmarks();
				break;
				
			case SCREEN_SET:
				set.removeFromBookmarks();
				break;
		}
	}
	
	function cbShowInBrowser() {
		switch(browsr.screen)
		{
			case SCREEN_HOME:
				home.showInBrowser();
				break;
				
			case SCREEN_PHOTOSTREAM:
				photostream.showInBrowser();
				break;
				
			case SCREEN_PHOTO:
				photo.showInBrowser();
				break;
			
			/* needs owner info */
			/*
			case SCREEN_SETS:
				sets.showInBrowser();
				break;
				
			case SCREEN_SET:
				set.showInBrowser();
				break;
			*/
			
			case SCREEN_COLLECTIONS:
				collections.showInBrowser();
				break;
				
			case SCREEN_COLLECTION:
				collection.showInBrowser();
				break;
				
			case SCREEN_CONTACTS:
				contacts.showInBrowser();
				break;
				
			case SCREEN_CONTACT:
				contact.showInBrowser();
				break;
			
			/* not needed */
			/*
			case SCREEN_TAGS:
				tags.showInBrowser();
				break;
			*/
			
			case SCREEN_COMMENTS:
				comments.showInBrowser();
				break;
				
			case SCREEN_FAVORITES:
				favorites.showInBrowser();
				break;
				
			case SCREEN_DESCRIPTION:
				description.showInBrowser();
				break;
				
			case SCREEN_RECENT_ACTIVITY:
				recent_activity.showInBrowser();
				break;
				
			case SCREEN_ACTIVITIES:
				activities.showInBrowser();
				break;
				
			case SCREEN_EXPLORE:
				explore.showInBrowser();
				break;
				
			case SCREEN_SPHOTO:
				sphoto.showInBrowser();
				break;
				
			case SCREEN_SEARCH:
				search.showInBrowser();
				break;
				
			case SCREEN_PLACES:
				places.showInBrowser();
				break;
				
			case SCREEN_SIZES:
				sizes.showInBrowser();
				break;
		}
		
		toolbar.deselectById(MENU_SHOW_IN_BROWSER.id);
	}
	
	function cbSettings() {
	
		var params = [];
		
		Helper.destroyCurrentScreen();
		
		browsr.addEvent('Settings', settings.show, params, 0, null, 'icon');
		settings.show(params);
		params = null;
	}
	
	function cbSwitchToTabs() {
		browsr.mode = MODE_TAB;
		
		browsr.screens[browsr.screen].switchToTabs();
	}
	
	function cbSwitchToList() {
		browsr.mode = MODE_LIST;
		
		browsr.screens[browsr.screen].switchToList();
	}
	
	function cbShowSubItems() {
		toolbar.showSubItems();
	}
	
	function cbFrameNo() {
		if(browsr)
		{
			browsr.frame = FRAME_NONE;
			
			if(browsr.screen == SCREEN_SPHOTO)
				sphoto.setFrame(FRAME_NONE);
		}
	}
	
	function cbFrameWhite() {
		if(browsr)
		{
			browsr.frame = FRAME_WHITE;
			
			if(browsr.screen == SCREEN_SPHOTO)
				sphoto.setFrame(FRAME_WHITE);
		}
	}
	
	function cbFrameBlack() {
		if(browsr)
		{
			browsr.frame = FRAME_BLACK;
			
			if(browsr.screen == SCREEN_SPHOTO)
				sphoto.setFrame(FRAME_BLACK);
		}
	}
	
	function cbFramePolaroid() {
		if(browsr)
		{
			browsr.frame = FRAME_POLAROID;
			
			if(browsr.screen == SCREEN_SPHOTO)
				sphoto.setFrame(FRAME_POLAROID);
		}
	}
	
	function cbBgNo() {
		if(browsr)
		{
			browsr.bg = BG_NONE;
			$('viewport_area').style.background = 'transparent';
		}
	}
	
	function cbBgWhite() {
		if(browsr)
		{
			browsr.bg = BG_WHITE;
			$('viewport_area').className = 'viewport_area white';
		}
	}
	
	function cbBgBlack() {
		if(browsr)
		{
			browsr.bg = BG_BLACK;
			$('viewport_area').className = 'viewport_area black';
		}
	}
	
	function cbBgCustom() {
		if(browsr)
		{
			browsr.bg = BG_CUSTOM;
			$('viewport_area').className = 'theme1';
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	