	
	function Flickr()
	{
		//this.api_key = "ab1f9693c9afc17a28a53542ebd20994";
		//this.secret = "04ca280e88a09c40";
		this.api_key = "7ae53b48aac09ed1840751cf848378c0";
		this.secret = "c4e05c6ba1e62f45";
		this.auth_url = "http://www.flickr.com/auth-72157616839897013";
		this.req = [];
		this.url = "";
		this.callback = [];
	}
	
/*
	Flickr.prototype.create_request = function() {
		this.req = null;
		try {
			this.req = new XMLHttpRequest();
		} catch( failed ) {
			alert("Cannot create request");
			this.req = null;
		}
	}
	
	Flickr.prototype.send_request = function(params, signed) {
		this.create_request();
		if(this.req != null)
		{
			this.build_url(params, signed);
			this.req.open("GET", this.url, true);
			this.req.onreadystatechange = this.handle_response;
			$('login_icon').setAttribute('src', './images/loader_white.gif');
			this.req.send(null);
		}
	}
*/

	Flickr.prototype.create_request = function(priority) {
		var i = 0;
		
		if(priority == PRI_HIGH)
		{
			if(this.req[0])
				i = 1;
			else
				i = 0;
			this.req.splice(i, 0, null);
		}
		else
		{
			i = this.req.length;
			this.req[i] = null;
		}
		
		try {
			this.req[i] = new XMLHttpRequest();
			return i; / * typically the index */
		} catch( failed ) {
			alert("Cannot create request");
			this.req[i] = null;
			return -1;
		}
	}
	
	Flickr.prototype.send_request = function(params, signed, callback, priority) {
		var i = this.create_request(priority);
		
		if(this.req[i] != null)
		{
			this.callback[i] = callback;
			this.build_url(params, signed);
			this.req[i].open("GET", this.url, true);
			this.req[i].onreadystatechange = this.handle_response;
			//$('login_icon').setAttribute('src', loaderImage);
			Helper.showLoaderImage();
			
			if((i == 0) && (this.req[i].readyState == 1))
				this.send_next_request();
		}
	}
	
	Flickr.prototype.send_next_request = function() {
		if(this.req && this.req[0])
		{
			this.req[0].send(null);
		}
	}
	
	Flickr.prototype.purge_all = function() {
		if(this.req || this.callback)
		{
			var treq = this.req;
			this.req = [];
			
			var tcb = this.callback;
			this.callback = [];
			
			while(treq.length)
			{
				treq.shift();
			}
			
			while(tcb.length)
			{
				tcb.shift();
			}
		}
	}
	
	Flickr.prototype.handle_response = function() {
		/* this refers to the window */
		if(flickr.req && flickr.req[0])
		{
			if(flickr.req[0].readyState == 4)
			{
				//$('login_icon').setAttribute('src', flickrImage);
				//alert('Yay! we got some response');
				Helper.hideLoaderImage();
				
				if(flickr.req[0].status == 200)
				{
					var rsp = eval('(' + flickr.req[0].responseText + ')');
					flickr.req[0].abort();
					flickr.req[0] = null;
					flickr.req.shift();
					
					if(flickr.callback[0] != null)
					{
						flickr.callback[0](rsp);
						flickr.callback[0] = null;
						flickr.callback.shift();
					}
				}
				else
				{
					var rsp = null;
					flickr.req[0].abort();
					flickr.req[0] = null;
					flickr.req.shift();
					
					if(flickr.callback[0] != null)
					{
						flickr.callback[0](rsp);
						flickr.callback[0] = null;
						flickr.callback.shift();
					}
				}
				flickr.send_next_request();
			}
			else if(flickr.req.readyState < 4)
			{
				//$('login_icon').setAttribute('src', './images/loader_white.gif');
				Helper.showLoaderImage();
			}
		}
	}
	
	
	Flickr.prototype.build_url = function(params, signed) {
		var base_url = "http://api.flickr.com/services/rest/?";
		
		params["api_key"] = this.api_key;
		params["format"] = "json";
		params["nojsoncallback"] = "1";
		
		var url = base_url;
		
		var i;
		for(i in params)
		{
			if(i != 'method')
			{
				url = url + '&';
			}
			
			url = url + i + '=' + params[i];
		}
		
		if(signed == true)
		{	
			var sig_params = [];
			
			var i;
			for(i in params)
			{
				if(i != 'undefined')
					sig_params.push(i);
			}
			
			sig_params.sort();
			
			var sign_string = this.secret;
		
			for(i=0; i < sig_params.length; i++)
			{
				sign_string = sign_string + sig_params[i] + params[sig_params[i]];
			}
			
			url = url + '&api_sig=' + md5_sum(sign_string);
		}
		
		//console.log(url);
		this.url = url;
	}
	
	Flickr.prototype.build_photo_url = function(farm_id, server_id, id, secret, size) {
		//http://farm{farm-id}.static.flickr.com/{server-id}/{id}_{secret}_[mstb].jpg
		
		var purl = "http://farm" + farm_id + ".static.flickr.com/" + server_id + "/" + id + "_" + secret;

		switch(size)
		{
			case PHOTO_S:
				purl = purl + "_s.jpg";
				break;
				
			case PHOTO_T:
				purl = purl + "_t.jpg";
				break;
				
			case PHOTO_M:
				purl = purl + "_m.jpg";
				break;
				
			case PHOTO_NONE:
				purl = purl + ".jpg";
				break;
				
			case PHOTO_B:
				purl = purl + "_b.jpg";
				break;
		}
		
		return purl;
	}
	
	Flickr.prototype.build_buddy_icon_url = function(icon_server, icon_farm, nsid) {
		if(icon_server > 0)
		{
			//http://farm{icon-farm}.static.flickr.com/{icon-server}/buddyicons/{nsid}.jpg
			return 'http://farm' + icon_farm + '.static.flickr.com/' + icon_server + '/buddyicons/' + nsid + '.jpg';
		}
		else
		{
			//http://www.flickr.com/images/buddyicon.jpg
			return 'http://www.flickr.com/images/buddyicon.jpg';
			
		}
	}
	
	Flickr.prototype.build_auth_url = function(frob) {
		//http://flickr.com/services/auth/?api_key=[api_key]&perms=[perms]&frob=[frob]&api_sig=[api_sig]
		var url = 'http://www.flickr.com/services/auth/?';
		
		var params = [];
		
		params["api_key"] = this.api_key;
		params["perms"] = 'read';
		params["frob"] = frob;
		
		var i;
		var sig_params = [];
		
		for(i in params)
		{
			if(i != 'api_key')
			{
				url = url + '&';
			}
			
			if(i != 'undefined')
				sig_params.push(i);
			
			url = url + i + '=' + params[i];
		}
			
		sig_params.sort();
			
		var sign_string = this.secret;
		
		for(i=0; i < sig_params.length; i++)
		{
			sign_string = sign_string + sig_params[i] + params[sig_params[i]];
		}
			
		url = url + '&api_sig=' + md5_sum(sign_string);
		
		return url;
	}
	
	/* List of Api's Supported */
	
	Flickr.prototype.auth_getFullToken = function(mini_token, callback, priority) {
		var params = [];
		
		params["method"] = "flickr.auth.getFullToken";
		params["mini_token"] = mini_token;
		
		this.send_request(params, true, callback, priority);
	}

	Flickr.prototype.auth_getFrob = function(callback, priority) {
		var params = [];
		
		params["method"] = "flickr.auth.getFrob";
		
		this.send_request(params, true, callback, priority);
	}
	
	Flickr.prototype.auth_getToken = function(frob, callback, priority) {
		var params = [];
		
		params["method"] = "flickr.auth.getToken";
		params["frob"] = frob;
		
		this.send_request(params, true, callback, priority);
	}

	Flickr.prototype.auth_checkToken = function(auth_token, callback, priority) {
		var params = [];
		
		params["method"] = "flickr.auth.checkToken";
		params["auth_token"] = auth_token;
		
		this.send_request(params, true, callback, priority);
	}
	
	/* Need to include all options */
	Flickr.prototype.photos_search = function(params, callback, priority) {
		if(params)
		{	
			if(params["auth_token"])
			{
				this.send_request(params, true, callback, priority);
			}
			else
			{
				this.send_request(params, false, callback, priority);
			}
		}
	}
	
	Flickr.prototype.photos_getInfo = function(auth_token, photo_id, secret, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getInfo';
		
		if(auth_token)
			params["auth_token"] = auth_token;
		
		if(photo_id)
			params["photo_id"] = photo_id;
		else
			return;
			
		if(secret)
			params["secret"] = secret;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photos_getAllContexts = function(auth_token, photo_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getAllContexts';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photo_id)
			params["photo_id"] = photo_id;
		else
			return;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photos_getFavorites = function(auth_token, photo_id, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getFavorites';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photo_id)
			params["photo_id"] = photo_id;
		else
			return;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photos_getSizes = function(auth_token, photo_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getSizes';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photo_id)
			params["photo_id"] = photo_id;
		else
			return;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photos_getExif = function(auth_token, photo_id, secret, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getExif';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photo_id)
			params["photo_id"] = photo_id;
		else
			return;
			
		if(secret)
			params["secret"] = secret;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photos_getContactsPhotos = function(auth_token, count, just_friends, single_photo, include_self, extras, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getContactsPhotos';
		
		if(auth_token)
			params["auth_token"] = auth_token;
		else
			return;
			
		if(count)
			params["count"] = count;
			
		if(just_friends)
			params["just_friends"] = 1; /* just_friends */
			
		if(single_photo)
			params["single_photo"] = 1 /* single_photo */
			
		if(include_self)
			params["include_self"] = 1 /* include_self */
			
		if(extras)
			params["extras"] = extras;
			
		this.send_request(params, true, callback, priority);
	}
	
	Flickr.prototype.photos_getContactsPublicPhotos = function(auth_token, user_id, count, just_friends, single_photo, include_self, extras, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getContactsPublicPhotos';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(user_id)
			params["user_id"] = user_id;
		else
			return;
			
		if(count)
			params["count"] = count;
			
		if(just_friends)
			params["just_friends"] = 1; /* just_friends */
			
		if(single_photo)
			params["single_photo"] = 1 /* single_photo */
			
		if(include_self)
			params["include_self"] = 1 /* include_self */
			
		if(extras)
			params["extras"] = extras;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photos_getRecent = function(auth_token, extras, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.getRecent';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(extras)
			params["extras"] = extras;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photos_comments_getList = function(auth_token, photo_id, min_comment_date, max_comment_date, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photos.comments.getList';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photo_id)
			params["photo_id"] = photo_id;
		else
			return;
			
		if(min_comment_date)
			params["min_comment_date"] = min_comment_date;
			
		if(max_comment_date)
			params["max_comment_date"] = max_comment_date;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.contacts_getList = function(auth_token, filter, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.contacts.getList';
		
		if(auth_token)
			params["auth_token"] = auth_token;
		else
			return;
		
		if(filter)
			params["filter"] = filter;
		
		if(page)
			params["page"] = page;
		
		if(per_page)
			params["per_page"] = per_page;
		
		this.send_request(params, true, callback, priority);
	}
	
	Flickr.prototype.contacts_getListRecentlyUploaded = function(auth_token, date_lastupload, filter, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.contacts.getListRecentlyUploaded';
		
		if(auth_token)
			params["auth_token"] = auth_token;
		else
			return;
			
		if(date_lastupload)
			params["date_lastupload"] = date_lastupload;
			
		if(filter)
			params["filter"] = filter;
			
		this.send_request(params, true, callback, priority);
	}
	
	Flickr.prototype.contacts_getPublicList = function(auth_token, user_id, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.contacts.getPublicList';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(user_id)
			params["user_id"] = user_id;
		else
			return;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
		
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.people_getInfo = function(auth_token, user_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.people.getInfo';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(user_id)
			params["user_id"] = user_id;
		else
			return;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.people_findByEmail = function(find_email, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.people.findByEmail';
		
		if(find_email)
			params["find_email"] = find_email;
		else
			return;
			
		this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.people_findByUsername = function(username, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.people.findByUsername';
		
		if(username)
			params["username"] = username;
		else
			return;
			
		this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photosets_getList = function(auth_token, user_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photosets.getList';
		
		if(user_id)
			params["user_id"] = user_id;
		
		if(auth_token)
			params["auth_token"] = auth_token;
		
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photosets_getPhotos = function(auth_token, photoset_id, extras, privacy_filter, media, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photosets.getPhotos';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photoset_id)
			params["photoset_id"] = photoset_id;
		else
			return;
			
		if(extras)
			params["extras"] = extras;
			
		if(privacy_filter)
			params["privacy_filter"] = privacy_filter;
			
		if(media)
			params["media"] = media;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photosets_getInfo = function(auth_token, photoset_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photosets.getInfo';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photoset_id)
			params["photoset_id"] = photoset_id;
		else
			return;
		
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.photosets_comments_getList = function(auth_token, photoset_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.photosets.comments.getList';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photoset_id)
			params["photoset_id"] = photoset_id;
		else
			return;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.tags_getListPhoto = function(auth_token, photo_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.tags.getListPhoto';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(photo_id)
			params["photo_id"] = photo_id;
		else
			return;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.tags_getListUser = function(auth_token, user_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.tags.getListUser';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(user_id)
			params["user_id"] = user_id;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.tags_getListUserPopular = function(auth_token, user_id, count, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.tags.getListUserPopular';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(user_id)
			params["user_id"] = user_id;
			
		if(count)
			params["count"] = count;
		
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.collections_getTree = function(auth_token, collection_id, user_id, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.collections.getTree';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(collection_id)
			params["collection_id"] = collection_id;
			
		if(user_id)
			params["user_id"] = user_id;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.favorites_getList = function(auth_token, user_id, min_fav_date, max_fav_date, extras, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.favorites.getList';
		
		if(auth_token)
			params["auth_token"] = auth_token;
		else
			return;
			
		if(user_id)
			params["user_id"] = user_id;
			
		if(min_fav_date)
			params["min_fav_date"] = min_fav_date;
			
		if(max_fav_date)
			params["max_fav_date"] = max_fav_date;
			
		if(extras)
			params["extras"] = extras;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.favorites_getPublicList = function(auth_token, user_id, min_fav_date, max_fav_date, extras, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.favorites.getPublicList';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(user_id)
			params["user_id"] = user_id;
		else
			return;
			
		if(min_fav_date)
			params["min_fav_date"] = min_fav_date;
			
		if(max_fav_date)
			params["max_fav_date"] = max_fav_date;
			
		if(extras)
			params["extras"] = extras;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.activity_userComments = function(auth_token, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.activity.userComments';
		
		if(auth_token)
			params["auth_token"] = auth_token;
		else
			return;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.activity_userPhotos = function(auth_token, timeframe, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.activity.userPhotos';
		
		if(auth_token)
			params["auth_token"] = auth_token;
		else
			return;
			
		if(timeframe)
			params["timeframe"] = timeframe;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.interestingness_getList = function(auth_token, date, extras, page, per_page, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.interestingness.getList';
		
		if(auth_token)
			params["auth_token"] = auth_token;
			
		if(date)
			params["date"] = date;
			
		if(extras)
			params["extras"] = extras;
			
		if(page)
			params["page"] = page;
			
		if(per_page)
			params["per_page"] = per_page;
			
		if(params["auth_token"])
			this.send_request(params, true, callback, priority);
		else
			this.send_request(params, false, callback, priority);
	}
	
	Flickr.prototype.places_find = function(query, callback, priority) {
		var params = [];
		
		params["method"] = 'flickr.places.find';
		
		if(query)
			params["query"] = query;
		else
			return;
			
		this.send_request(params, false, callback, priority);
	}