	
	function Login()
	{
		this.frob = '';
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}

	Login.prototype.initialize = function() {
		browsr.screen = SCREEN_LOGIN;
		
		this.scroll = new Scroll();		
		/* adding to the parent div */
		this.scroll.addTo('content_area');
		$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
		$('scrollpanel').style.height	= (200 - 5) + 'px';
			
		/*
		$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
		$('hscrollpanel').style.width	= (240 - 5) + 'px';
		*/
		
		this.div = $('content_area');
		this.div.style.display = 'block';
		
		/* Post processing */
		Helper.hideNavbar();
		Helper.hideTabbar();
		
		/* TODO: Move somewhere else!! */
		$('content_area').style.height = ($('content_area').clientHeight + 40) + 'px';
		$('scrollpanel').style.height = ($('content_area').clientHeight - 5) + 'px';
		$('scrollpanel').style.top = ($('scrollpanel').offsetTop - 40) + 'px';
	}
	
	Login.prototype.destroy = function() {
		flickr.purge_all();
		
		if($('rsignin'))
			$('rsignin').blur();
			
		if($('accesskey'))
			$('accesskey').blur();
			
		if($('mini1'))
			$('mini1').blur();
			
		if($('mini2'))
			$('mini2').blur();
			
		if($('mini3'))
			$('mini3').blur();
			
		if($('nsignin'))
			$('nsignin').blur();
		
		this.frob = '';
		
		/* TODO: verify */
		Helper.destroy(this);
		$('content_area').style.height = ($('content_area').clientHeight - 40) + 'px';
	}
	
	Login.prototype.resize = function() {
		this.scroll.resize();
	}
	
	Login.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(this.scroll)
				{
					if(this.scroll.scrollarea.clientHeight > this.scroll.scroll.clientHeight)
						this.scroll.scrollUp(20);
				}
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(this.scroll)
				{
					if(this.scroll.scrollarea.clientHeight > this.scroll.scroll.clientHeight)
						this.scroll.scrollDown(20);
				}
				break;
		}
	}
	
	Login.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(true);
			wid(MENU_GOT_LOST.id).setDimmed(true);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(true);
			wid(MENU_REFRESH.id).setDimmed(true);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
		}
		else
		{
			toolbar.hide(MENU_WHERE_AM_I.id);
			toolbar.hide(MENU_GOT_LOST.id);
			toolbar.hide(MENU_CLEAR_HISTORY.id);
			toolbar.hide(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			toolbar.hide(MENU_SWITCH_TO_TABS.id);
			toolbar.hide(MENU_SWITCH_TO_LIST.id);
		}
	}
	
	Login.prototype.showNokia = function(params) {
	
		login.initialize();
	
		var rcont = Helper.getRoundedContainer(0);
		var cnt = Helper.getRcContent(rcont);
	
		/* nickname */
		var tnickname = Helper.getP(null, 'login', 'Nickname :');
		var inickname = Helper.getTextBox('nickname', 'login', '12', '', '');
		
		var unickname = Helper.getUl(null, 'login');
		var lnickname = Helper.getLi(null, 'login');
		
		lnickname.appendChild(tnickname);
		lnickname.appendChild(inickname);
		unickname.appendChild(lnickname);
		cnt.appendChild(unickname);
		
		/* signin button */
		var rsignin = Helper.getButton('rsignin', 'signin', '');
		var usignin = Helper.getUl(null, 'login');
		var lsignin = Helper.getLi(null, 'loginbuttons');
		rsignin.setAttribute('onclick', 'login.rsigninHandler()');
		
		lsignin.appendChild(rsignin);
		usignin.appendChild(lsignin);
		cnt.appendChild(usignin);
		
		/* hr */
		var hr = Helper.getHr('login');
		cnt.appendChild(hr);
		
		/* get me an access key */
		var iaccesskey = Helper.getButton('accesskey', 'accesskey', '');
		var uaccesskey = Helper.getUl(null, 'login');
		var laccesskey = Helper.getLi(null, 'loginbuttons');
		iaccesskey.setAttribute('onclick', 'login.accessKeyHandler()');
		
		laccesskey.appendChild(iaccesskey);
		uaccesskey.appendChild(laccesskey);
		cnt.appendChild(uaccesskey);
		
		/* mini token */
		var tminitoken = Helper.getP(null, 'login', 'Mini Token :');
		var imini1 = Helper.getTextBox('mini1', 'login', '2', '3', '');
		var imini2 = Helper.getTextBox('mini2', 'login', '2', '3', '');
		var imini3 = Helper.getTextBox('mini3', 'login', '2', '3', '');
		
		var uminitoken = Helper.getUl(null, 'login');
		var lminitoken = Helper.getLi(null, 'login');
		
		lminitoken.appendChild(tminitoken);
		lminitoken.appendChild(imini1);
		lminitoken.appendChild(imini2);
		lminitoken.appendChild(imini3);
		uminitoken.appendChild(lminitoken);
		cnt.appendChild(uminitoken);
		
		/* remember me */
		var iremember = Helper.getCheckBox('remember', 'login', 'rememberme');
		var tremember = Helper.getP(null, 'login', 'Remember me');
		var uremember = Helper.getUl(null, 'login');
		var lremember = Helper.getUl(null, 'login');
		
		lremember.appendChild(iremember);
		lremember.appendChild(tremember);
		uremember.appendChild(lremember);
		cnt.appendChild(uremember);
		
		/* signin & cancel buttons */
		var nsignin = Helper.getButton('nsignin', 'signin', '');
		nsignin.setAttribute('onclick', 'login.nsigninHandler()');
		
		var ucontrols = Helper.getUl(null, 'login');
		var lcontrols = Helper.getLi(null, 'loginbuttons');
		
		lcontrols.appendChild(nsignin);
		ucontrols.appendChild(lcontrols);
		cnt.appendChild(ucontrols);
		
		this.scroll.add(rcont);
		this.resize();
		this.scroll.updateScrollbar();
		this.updateMenus();
	}
	
	Login.prototype.showAIR = function(params) {
	
		login.initialize();
	
		var rcont = Helper.getRoundedContainer(0);
		var cnt = Helper.getRcContent(rcont);
		
		/* nickname */
		var tnickname = Helper.getP(null, 'login', 'Nickname :');
		var inickname = Helper.getTextBox('nickname', 'nickname', '12', '', '');
		inickname.addEventListener('keypress', function(e) { login.nicknameHandler(e); }, false);
		
		var bgo = Helper.getButton('go', 'go', '');
		bgo.addEventListener('click', function() { login.goHandler(); }, false);
		
		cnt.appendChild(tnickname);
		cnt.appendChild(inickname);
		cnt.appendChild(bgo);
		
		var tnote = Helper.getP(null, 'loginnote', '(Just for remembering you!)');
		var cnote = Helper.getCenter();
		
		cnote.appendChild(tnote);
		cnt.appendChild(cnote);
		
		/* authorize button */
		var bauthorize = Helper.getButton('authorize', 'authorize', '');
		var dauthorize = Helper.getDiv('dauthorize', 'authorize');
		var cauthorize = Helper.getCenter();
		bauthorize.addEventListener('click', function() { login.authorizeHandler(); }, false);
		
		dauthorize.appendChild(bauthorize);	
		cauthorize.appendChild(dauthorize);
		cnt.appendChild(cauthorize);
		
		/* return here note */
		var treturn = Helper.getP(null, 'loginnote', 'Click on after Authorizing me!');
		var dreturn = Helper.getDiv('dreturn', 'loginnote');
		var creturn = Helper.getCenter();
		
		dreturn.appendChild(treturn);
		creturn.appendChild(dreturn);
		cnt.appendChild(creturn);
		
		/* complete authorization button */
		
		var bcomplete = Helper.getButton('comp_auth', 'comp_auth', '');
		var dcomplete = Helper.getDiv('dcomp_auth', 'comp_auth');
		var ccomplete = Helper.getCenter();
		dcomplete.addEventListener('click', function() { login.completeAuthHandler(); }, false);
		
		dcomplete.appendChild(bcomplete);
		ccomplete.appendChild(dcomplete);
		cnt.appendChild(ccomplete);
		
		dauthorize.style.display = 'none';
		dreturn.style.display = 'none';
		dcomplete.style.display = 'none';
		
		login.scroll.add(rcont);
		
		//Helper.placeInCenter(rcont, login.div);
		
		login.resize();
		login.scroll.updateScrollbar();
		login.updateMenus();
		
		$('nickname').focus();
		flickr.auth_getFrob(login.hrGetFrob, PRI_HIGH);
	}
	
	Login.prototype.rsigninHandler = function() {
		if($('rsignin'))
		{
			/* validations */
			if(($('nickname').value == ''))
			{
				alert('Please enter a nickname to sign in');
				$('nickname').focus();
				$('rsignin').blur();
				return;
			}
			
			var key = 'User_' + $('nickname').value;
			
			if(widget.preferenceForKey(key))
			{
				var token = widget.preferenceForKey(key);
				flickr.auth_checkToken(token, login.hrCheckToken, PRI_HIGH);
			}
			else
			{
				alert('The Auth key for this user is missing. Please get a new mini token to continue!');
				$('accesskey').focus();
				$('rsignin').blur();
				return;
			}
		}
	}
	
	Login.prototype.accessKeyHandler = function() {
		widget.openURL(encodeURI('http://www.flickr.com/auth-72157616839897013'));
	}
	
	Login.prototype.nsigninHandler = function() {
		if($('nsignin'))
		{
			/* validations */
			if(($('remember').checked == true) && ($('nickname').value == ''))
			{
				alert('Please enter a nickname to remember you next time.');
				$('nickname').focus();
				$('nsignin').blur();
				return;
			}
			
			var key = 'User_' + $('nickname').value;
			if(widget.preferenceForKey(key))
			{
				alert('User already exists! Either use the other sign in or enter a different nickname');
				$('nickname').focus();
				$('nsignin').blur();
			}
			
			if($('mini1').value == '')
			{
				alert('Please enter the first 3 digits of the mini key');
				$('mini1').focus();
				$('nsignin').blur();
				login.scroll.scrollToBottom();
				return;
			}
			
			if($('mini2').value == '')
			{
				alert('Please enter the second 3 digits of the mini key');
				$('mini2').focus();
				$('nsignin').blur();
				login.scroll.scrollToBottom();
				return;
			}
			
			if($('mini3').value == '')
			{
				alert('Please enter the last 3 digits of the mini key');
				$('mini3').focus();
				$('nsignin').blur();
				login.scroll.scrollToBottom();
				return;
			}
			
			var mini1 = $('mini1').value;
			var mini2 = $('mini2').value;
			var mini3 = $('mini3').value;
			
			var mini_key = mini1 + '-' + mini2 + '-' + mini3;
			
			/* send a request to flickr */
			flickr.auth_getFullToken(mini_key, login.hrGetToken, PRI_HIGH);
		}
	}
	
	Login.prototype.nicknameHandler = function(e) {
		if($('nickname'))
		{
			if(e.keyCode == 13)
			{
				$('nickname').blur();
				login.goHandler();
			}
		}
	}
	
	Login.prototype.goHandler = function() {
		if($('go') && $('nickname'))
		{
			if($('nickname').value != '')
			{
				var token = air.EncryptedLocalStore.getItem('User_' + $('nickname').value); 
				
				if(token)
				{
					flickr.auth_checkToken(token, login.hrCheckToken, PRI_HIGH);
				}
				else
				{
					alert('This user needs to authorize (again)!');
					$('nickname').focus();
				}
			}
			else
			{
				alert('Please enter a name!');
				$('nickname').focus();
			}
		}
	}
	
	Login.prototype.authorizeHandler = function() {
		if($('authorize'))
		{
			/* validations */
			if(login.frob)
			{
				alert('This will open a page in your default browser to perform authorization!');
				var url = flickr.build_auth_url(this.frob);
			
				var request = new air.URLRequest(url);
				try {
					air.navigateToURL(request);
				} catch (e) { }
				
				$('dauthorize').style.display = 'none';
				$('dreturn').style.display = 'block';
				$('dcomp_auth').style.display = 'block';
			}
		}
	}
	
	Login.prototype.completeAuthHandler = function() {
		if($('comp_auth'))
		{
			flickr.auth_getToken(this.frob, this.hrGetToken, PRI_HIGH);
		}
	}
	
	Login.prototype.hrGetToken = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(rsp.auth && rsp.auth.token)
				{
					if(user == null)
						user = new User();
						
					user.token = rsp.auth.token._content;
					user.perms = rsp.auth.perms._content;
					
					user.user_nsid = rsp.auth.user.nsid;
					user.username = rsp.auth.user.username;
					user.fullname = rsp.auth.user.fullname;
					
					if(isNokia)
					{
						/* store this key if needed */
						if($('remember').checked)
						{
							var key = 'User_' + $('nickname').value;
							widget.setPreferenceForKey(user.token, key);
						}
					}
					else
					{
						if($('nickname').value != '')
						{
							var key = 'User_' + $('nickname').value; 
							var bytes = new air.ByteArray(); 
							bytes.writeUTFBytes(user.token); 
							
							air.EncryptedLocalStore.setItem(key, bytes);
						}
					}
						
					var params = [];
					params["user_nsid"] = user.user_nsid;
					
					login.destroy();
					
					browsr.addEvent('Home', home.show, params, 0);
					home.show(params);
					params = null;
				}
				else
				{
					alert('Unable to get an authentication token');
				}
			}
			else
			{
				alert(rsp.message);
				$('mini1').value = '';
				$('mini2').value = '';
				$('mini2').value = '';
				$('accesskey').focus();
				$('nsignin').blur();
			}
		}
	}
	
	Login.prototype.hrCheckToken = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(rsp.auth && rsp.auth.token)
				{
					if(user == null)
						user = new User();
						
					user.token = rsp.auth.token._content;
					user.perms = rsp.auth.perms._content;
					
					user.user_nsid = rsp.auth.user.nsid;
					user.username = rsp.auth.user.username;
					user.fullname = rsp.auth.user.fullname;
					
					var params = [];
					params["user_nsid"] = user.user_nsid;
					
					login.destroy();
					
					browsr.addEvent('Home', home.show, params, 0);
					home.show(params);
					params = null;
				}
				else
				{
					alert('Unable to get an authentication token');
				}
			}
			else
			{
				alert(rsp.message);
				
				if(isNokia)
				{
					$('mini1').value = '';
					$('mini2').value = '';
					$('mini3').value = '';
					$('accesskey').focus();
					$('nsignin').blur();
				}
			}
		}
	}
	
	Login.prototype.hrGetFrob = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(rsp.frob && rsp.frob._content)
					login.frob = rsp.frob._content;
						
				$('dauthorize').style.display = '';
			}
			else
			{
				alert(rsp.message);
			}
		}
		else
		{
			alert('Couldn\'t get a Frob!');
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	