/* This is the main js file which is used for capturing keyevents before sending it to respective view's js */

	var request = null;
	var flickr = null;
	var user = null;
	var bmarks = null;
	var toolbar = null;
	var home = null;
	var photostream = null;
	var photo = null;
	var sphoto = null;
	var favorites = null;
	var comments = null;
	var comment = null;
	var contacts = null;
	var contact = null;
	var sets = null;
	var set = null;
	var collections = null;
	var collection = null;
	var tags = null;
	var description = null;
	var recent = null;
	var recent_activity = null;
	var activities = null;
	var activity = null;
	var explore = null;
	var search = null;
	var places = null;
	var sizes = null;
	var notes = null;
	var whereami = null;
	var bookmarksmenu = null;
	var bookmarks = null;
	var settings = null;
	var miniview = null;
	var login = null;
	var images = null;
	var browsr = null;
	var alphabets = null;
	var wdl = null;
	
	var isNokia = false;

	var bulletImage = './images/tmp_icon.png';
	var bookImage = './images/book.jpg';
	var defaultImage = './images/tmp_icon.png';
	var browsrImage = './images/photostream.png';
	
	/*
	var photoImage = './images/photo.png';
	var setsImage = './images/sets.png';
	var contactsImage = './images/contacts.png';
	var commentsImage = './images/comments.png';
	var notesImage = './images/notes.png';
	var favsImage = './images/favorites.png';
	var tagsImage = './images/tags.png';
	var flickrImage = './images/browsr_small.png';
	var loaderImage = './images/loader_white.gif';
	*/
	
	var photostreamImage    = './images/photostream.png';
	var contactsImage       = './images/contacts.png';
	var setsImage           = './images/sets.png';
	var collectionsImage    = './images/collections.png';
	var tagsImage           = './images/tags.png';
	var favoritesImage      = './images/favorites.png';
	var profileImage        = './images/profile.png';
	var recentActivityImage = './images/recent_activity.png';
	var bookmarksImage      = './images/tmp_icon_big.png';
	var searchImage         = './images/search.png';
	var exploreImage        = './images/tmp_icon_big.png';

	var photoImage          = './images/tmp_icon_big.png';
	var descriptionImage    = './images/description.png';
	var commentsImage       = './images/comments.png';
	var commentImage        = './images/comment.png';
	var notesImage          = './images/tmp_icon_big.png';
	var tagImage            = './images/tag.png';
	var placeImage          = './images/place.png';
	var contactImage        = './images/contact.png';
	var activityImage       = './images/tmp_icon_big.png';
	var exifImage           = './images/tmp_icon_big.png';
	var sizesImage          = './images/tmp_icon_big.png';
	var ownerImage          = './images/owner.png';
	
	var photosImage         = './images/photostream.png';
	var itemsImage          = './images/collections.png';
	
	var recentPhotosImage         = './images/recent_photos.png';
	var recentCommentsImage       = './images/recent_comments.png';
	var recentContactsPhotosImage = './images/recent_contacts.png';
	var recentContactsImage       = './images/recent_contacts.png';
	var recentPublicPhotosImage   = './images/recent_photos.png';
	
	var exploreTodayImage  = './images/tmp_icon_big.png';
	var exploreByDateImage = './images/tmp_icon_big.png';
	
	var searchNearMeImage         = './images/search_near_me.png';
	var searchTextImage           = './images/search_text.png';
	var searchTagsImage           = './images/search_tag.png';
	var searchPersonEmailImage    = './images/search_email.png';
	var searchPersonUsernameImage = './images/search_username.png';
	var searchPlacesImage         = './images/search_place.png';
	
	var bookmarksPhotosImage      = './images/tmp_icon_big.png';
	var bookmarksContactsImage    = './images/tmp_icon_big.png';
	var bookmarksSetsImage        = './images/tmp_icon_big.png';
	
	var whereAmIImage             = './images/tmp_icon_big.png';
	
	var favsImage = './images/favorites.png';
	var flickrImage = './images/tmp_icon.png';
	var loaderImage = './images/loader_white.gif';

	function $(elm) {
		return document.getElementById(elm);
	}
	
	function wid(id) {
		return window.menu.getMenuItemById(id);
	}
		
	function wkey(key) {
		return widget.preferenceForKey(key);
	}
	
	function wsetKey(value, key) {
		return widget.setPreferenceForKey(value, key);
	}
	
	function md5_sum(x) {
		return hex_md5(x);
	}
	
	function openURL(url) {
		if(isNokia)
			widget.openURL(encodeURI(url));
		else
			air.navigateToURL(new air.URLRequest(url));
	}

	function init()	{
		document.onkeydown = handle_keypress;
		
		//nokia_specific_init();
		
		//ff_hacks();		
		
		//preloadImages();
		
		toolbar = new Option();
		loadMenu();
		
		//loadSettings();
		
		//bmarks = new Bmarks();
		//bmarks.loadBmarks();
		Helper.hideNavbar();
		
		/* Hide the miniview button */
		$('mini_icon').style.display = 'none';
		$('change_mini_icon').style.display = 'none';
		
		/* Add event listener for going back */
		$('header_icon_bg').addEventListener('click', function() { goBack(); }, false);
		
		$('exit_icon').addEventListener('click', function(event) { window.nativeWindow.visible = false; }, false);
		$('mini_icon').addEventListener('click', cbShowMiniView, false);
		$('change_mini_icon').addEventListener('click', cbChangeMiniView, false);
		
		/* Add event listener for dragging */
		$('browsr_bar').addEventListener('mousedown', function(e) { headerDragStart(e); }, false);
		$('browsr_bar').addEventListener('mouseup',   function(e) { headerDragStop(e); }, false);
		$('browsr_bar').addEventListener('mousemove', function(e) { headerDragging(e); }, false);
		document.addEventListener('mouseup', function(e) { $('browsr_bar').drag = false; }, false );
		
		document.onmousedown =  function(e) { return false; };
		
		//document.addEventListener('DOMMouseScroll', function(e) { alert(e); }, false);
		document.onmousewheel = handle_mousescroll;
		
		user = new User();
		flickr = new Flickr();
		browsr = new Browsr();
		browsr.mode = MODE_TAB;
		
		MENU_FRAME_WHITE.select_bydefaut = true;
		
		if($('menu_bar_bottom_slider'))
		{
			if(Helper.isListMode())
				$('menu_bar_bottom_slider').addEventListener('click', cbSwitchToTabs, false);
			else
				$('menu_bar_bottom_slider').addEventListener('click', cbSwitchToList, false);
		}
		
		/* Adobe specific system tray icon */
		air_specific_init();
		
		login = new Login();
		browsr.screens[SCREEN_LOGIN] = login;
		
		home = new Home();
		browsr.screens[SCREEN_HOME] = home;
		
		photostream = new Photostream();
		browsr.screens[SCREEN_PHOTOSTREAM] = photostream;
		
		photo = new Photo();
		browsr.screens[SCREEN_PHOTO] = photo;
		
		sphoto = new SPhoto();
		browsr.screens[SCREEN_SPHOTO] = sphoto;
		
		favorites = new Favorites();
		browsr.screens[SCREEN_FAVORITES] = favorites;
		
		comments = new Comments();
		browsr.screens[SCREEN_COMMENTS] = comments;
		
		comment = new Comment();
		browsr.screens[SCREEN_COMMENT] = comment;
		
		sets = new Sets();
		browsr.screens[SCREEN_SETS] = sets;
		
		set = new Set();
		browsr.screens[SCREEN_SET] = set;
		
		collections = new Collections();
		browsr.screens[SCREEN_COLLECTIONS] = collections;
		
		collection = new Collection();
		browsr.screens[SCREEN_COLLECTION] = collection;
		
		contacts = new Contacts();
		browsr.screens[SCREEN_CONTACTS] = contacts;
		
		contact = new Contact();
		browsr.screens[SCREEN_CONTACT] = contact;
		
		tags = new Tags();
		browsr.screens[SCREEN_TAGS] = tags;
		
		description = new Description();
		browsr.screens[SCREEN_DESCRIPTION] = description;
		
		recent = new Recent();
		browsr.screens[SCREEN_RECENT] = recent;
		
		recent_activity = new RecentActivity();
		browsr.screens[SCREEN_RECENT_ACTIVITY] = recent_activity;
		
		activities = new Activities();
		browsr.screens[SCREEN_ACTIVITIES] = activities;
		
		activity = new Activity();
		browsr.screens[SCREEN_ACTIVITY] = activity;
		
		explore = new Explore();
		browsr.screens[SCREEN_EXPLORE] = explore;
		
		search = new Search();
		browsr.screens[SCREEN_SEARCH] = search;
		
		places = new Places();
		browsr.screens[SCREEN_PLACES] = places;
		
		sizes = new Sizes();
		browsr.screens[SCREEN_SIZES] = sizes;
		
		notes = new Notes();
		browsr.screens[SCREEN_NOTES] = notes;
		
		whereami = new WhereAmI();
		browsr.screens[SCREEN_WHERE_AM_I] = whereami;
		
		bookmarksmenu = new BookmarksMenu();
		browsr.screens[SCREEN_BOOKMARKS_MENU] = bookmarksmenu;
		
		bookmarks = new Bookmarks();
		browsr.screens[SCREEN_BOOKMARKS] = bookmarks;
		
		settings = new Settings();
		browsr.screens[SCREEN_SETTINGS] = settings;
		
		miniview = new MiniView();
		browsr.screens[SCREEN_MINI_VIEW] = miniview;
		
		if(isNokia)
			login.showNokia();
		else
			login.showAIR();
	}
	
	function handle_mousescroll(e) {
		var cnst = 360;
		
		/* Each scroll increases / decreases by a factor of 360 */
		/* scroll up - positive , scroll down - negative */
		
		var delta = e.wheelDeltaY / 360;
		var key = 0;
		
		/* Todo: Should scroll as many times as delta */
		
		if(delta > 0)
		{
			if(Helper.isListMode())
			{
				/* UP */
				key = KEY_UP;
			}
			else
			{
				/* LEFT */
				key = KEY_LEFT;
			}
			browsr.screens[browsr.screen].handleKeypress(key);
		}
		else if(delta < 0)
		{
			if(Helper.isListMode())
			{
				/* DOWN */
				key = KEY_DOWN;
			}
			else
			{
				/* RIGHT */
				key = KEY_RIGHT;
			}
			browsr.screens[browsr.screen].handleKeypress(key);
		}
	}

	function nokia_specific_init() {
		widget.setNavigationEnabled(false);
		
		menu.hideSoftkeys();
	}
	
	function air_specific_init() {
	
		/* Restoring the window to last known position */
		var scrX = air.EncryptedLocalStore.getItem('scrX');
		var scrY = air.EncryptedLocalStore.getItem('scrY');
		
		if(scrX && scrY)
			window.moveTo(scrX, scrY);
			
		var appUpdater = new runtime.air.update.ApplicationUpdaterUI();
		
		appUpdater.updateURL = "http://dl.dropbox.com/u/3017599/update.xml"; 
		appUpdater.delay = 1;
		appUpdater.isCheckForUpdateVisible = false;
		appUpdater.isDownloadUpdateVisible = true;
		appUpdater.isDownloadProgressVisible = true;
		
		
		try
		{
			appUpdater.initialize();
		} catch(e) { }
	
		var iconLoadComplete = function(event) 
	    { 
	        air.NativeApplication.nativeApplication.icon.bitmaps = [event.target.content.bitmapData]; 
	    } 
	     
	    air.NativeApplication.nativeApplication.autoExit = false; 
		
	    var iconLoad = new air.Loader(); 
	    var iconMenu = new air.NativeMenu(); 
		
		var restoreCommand = iconMenu.addItem(new air.NativeMenuItem("Restore"));
		restoreCommand.addEventListener(air.Event.SELECT,function(event){
			window.nativeWindow.visible = true;
			window.nativeWindow.restore();
			window.nativeWindow.activate();
		});
		
		iconMenu.addItem(new air.NativeMenuItem("", true));
		
		var exitCommand = iconMenu.addItem(new air.NativeMenuItem("Exit")); 
	    exitCommand.addEventListener(air.Event.SELECT,function(event){ 
				window.nativeWindow.restore();
				
				/* Store screenX and screenY */
				var scrX = new air.ByteArray(); 
				scrX.writeUTFBytes(window.screenX); 
				air.EncryptedLocalStore.setItem('scrX', scrX);
				
				var scrY = new air.ByteArray(); 
				scrY.writeUTFBytes(window.screenY); 
				air.EncryptedLocalStore.setItem('scrY', scrY);
				
	            air.NativeApplication.nativeApplication.icon.bitmaps = []; 
	            air.NativeApplication.nativeApplication.exit(); 
	    });
	 
	    if (air.NativeApplication.supportsSystemTrayIcon) { 
	        air.NativeApplication.nativeApplication.autoExit = false;
	        iconLoad.contentLoaderInfo.addEventListener(air.Event.COMPLETE,iconLoadComplete); 
	        iconLoad.load(new air.URLRequest("icons/Browsr_16.png")); 
	        air.NativeApplication.nativeApplication.icon.tooltip = "Browsr"; 
	        air.NativeApplication.nativeApplication.icon.menu = iconMenu; 
	        air.NativeApplication.nativeApplication.icon.addEventListener('click', function(event) {
				window.nativeWindow.visible = true;
				window.nativeWindow.restore();
				window.nativeWindow.activate();
			}, false); 
	    } 
	 
	    if (air.NativeApplication.supportsDockIcon) { 
	        iconLoad.contentLoaderInfo.addEventListener(air.Event.COMPLETE,iconLoadComplete); 
	        iconLoad.load(new air.URLRequest("icons/Browsr_128.png")); 
	        air.NativeApplication.nativeApplication.icon.menu = iconMenu; 
	    }
		
		window.nativeWindow.addEventListener(air.Event.CLOSING, function(event){
			event.preventDefault();
			event.target.visible = false;
		});
	}
	
	function on_resize() {
		if(isNokia)
		{
			if(Helper.isLandscape())
				menu.hideSoftkeys();
			else
				menu.showSoftkeys();
		}
		
		if(browsr && browsr.screens[browsr.screen])
			browsr.screens[browsr.screen].resize();
	}
	
	function handle_keypress(event) {
	
		if(browsr && browsr.screens[browsr.screen])
			browsr.screens[browsr.screen].handleKeypress(Helper.getKey(event));
	}
	
	function open_site() {
		/* This works fine.. integrate it later */
		widget.openURL(encodeURI('http://www.flickr.com'));
	}
	
	function headerDragStart(event) {
		$('browsr_bar').drag = true;
		$('browsr_bar').x = event.x;
		$('browsr_bar').y = event.y;
	}
	
	function headerDragStop(event) {
		$('browsr_bar').drag = true;
	}
	
	function headerDragging(event) {
		if($('browsr_bar').drag)
		{
			var x = (event.x - $('browsr_bar').x);
			var y = (event.y - $('browsr_bar').y);
			
			$('browsr_bar').x = event.x - x;
			$('browsr_bar').y = event.y - y;
			
			window.moveBy(x, y);
		}
	}
	
	function cbShowMiniView(e) {
		$('mini_icon').removeEventListener('click', cbShowMiniView, false);
		$('mini_icon').addEventListener('click', cbHideMiniView, false);
		
		var params = [];
		params["user"] = user;
		
		Helper.destroyCurrentScreen();
		
		browsr.addEvent('Mini View', miniview.showByContacts, params, 0);
		miniview.showByContacts(params);
		params = null;
	}
	
	function cbHideMiniView(e) {
		$('mini_icon').removeEventListener('click', cbHideMiniView, false);
		$('mini_icon').addEventListener('click', cbShowMiniView, false);
		goBack();
	}
	
	function cbChangeMiniView(e) {
		if(browsr && (browsr.screen == SCREEN_MINI_VIEW))
			miniview.changeType();
	}
		
	var ImagePreloader = {
		list: [],
		images: [],
		
		add: function( images ) {
			this.list = this.list.concat( images );
		},
		
		start: function() {
			for (var i = 0; i < this.list.length; i++) {
				var img = new Image();
				img.src = this.list[i];
				
				this.images.push( img );
			}		
		}
	}
	
	function preloadImages() {
		ImagePreloader.add( [
			"./images/flickr.png",
			"./images/loading_white.gif",
			"./images/tl.png",
			"./images/tr.png",
			"./images/bl.png",
			"./images/br.png",
			"./images/save.png",
			"./images/signin.png",
			"./images/accesskey.png",
			"./images/cancel.png",
			"./images/selected.png",
			"./images/icon.png",
			"./images/icon_selected.png",
			"./images/gframe.png",
			"./images/left.png",
			"./images/right.png",
			"./images/bullet.png",
			"./images/searchl.png",
			"./images/searchm.png",
			"./images/searchb.png",
			"./images/ok.png",
			"./images/cancel.png",
			"./images/onion.png",
			"./images/stripes.png",
			"./images/badge_l.png",
			"./images/photo.png",
			"./images/photostream.png",
			"./images/contacts.png",
			"./images/sets.png",
			"./images/collections.png",
			"./images/tags.png",
			"./images/favorites.png",
			"./images/profile.png",
			"./images/bookmarks.png",
			"./images/search.png",
			"./images/explore.png",
			"./images/explore_date.png",
			"./images/sizes.png",
			"./images/exif.png",
			"./images/comments.png",
			"./images/notes.png",
			"./images/description.png",
			"./images/recent_photos.png",
			"./images/recent_comments.png",
			"./images/recent_contacts.png",
			"./images/recent_contacts_photos.png",
			"./images/search_photo.png",
			"./images/search_contact.png",
			"./images/search_place.png",
			"./images/browsr_small.png",
			"./images/browsr_bnw.png",
			"./images/tabs.png",
			"./images/list.png"
			] );
			
		ImagePreloader.start();
	}
	
	