
	var Helper = {
	
		isLandscape : function() {
			if(window.innerHeight > window.innerWidth)
				return false;
			else
				return true;
		},
		
		isListMode : function() {
			if(browsr)
			{
				if(browsr.mode == MODE_LIST)
					return true;
				else
					return false;
			}
			
			return false;
		},
		
		isVisible : function(div) {
			if($(div))
			{
				if($(div).style.display == 'none')
					return false;
				else
					return true;
			}
			else
			{
				return false;
			}
		},
	
		showTitlebar : function() {
			if($('title_bar'))
				$('title_bar').style.display = 'block';
		},
		
		hideTitlebar : function() {
			if($('title_bar'))
				$('title_bar').style.display = 'none';
		},
	
		setTitle : function(str) {
			/* TODO: Fix this! */
			if($('title_text_shadow'))
			{
				var ps = $('title_text_shadow');
				var div = $('title_bar');
				ps.innerHTML = '' + str;
				ps.origText = '' + str;
				this.checkEllipsis(ps, div.clientWidth, div.clientHeight);
			}
			
			if($('title_text'))
			{
				var p = $('title_text');
				var div = $('title_bar');
				p.innerHTML = '' + str;
				p.origText = '' + str;
				this.checkEllipsis(p, div.clientWidth, div.clientHeight);
			}
		},
		
		showNavbar : function() {
			if($('nav_bar'))
				$('nav_bar').style.display = 'block';
		},
		
		hideNavbar : function() {
			if($('nav_bar'))
				$('nav_bar').style.display = 'none';
		},
		
		showTabbar : function() {
			if($('tab_bar'))
				$('tab_bar').style.display = 'block';
		},
		
		hideTabbar : function() {
			if($('tab_bar'))
				$('tab_bar').style.display = 'none';
		},
		
		showToolbar : function() {
			if($('tool_bar'))
				$('tool_bar').style.display = 'block';
		},
		
		hideToolbar : function() {
			if($('tool_bar'))
				$('tool_bar').style.display = 'none';
		},
		
		setNavigator : function(str) {
			if($('nav_bar'))
			{
				$('page_no_shadow').innerHTML = '' + str;
				$('page_no').innerHTML = '' + str;
			}
		},
		
		showNavLeft : function() {
			if($('nav_left'))
				$('nav_left').style.display = 'block';
		},
		
		hideNavLeft : function() {
			if($('nav_left'))
				$('nav_left').style.display = 'none';
		},
		
		showNavRight : function() {
			if($('nav_right'))
				$('nav_right').style.display = 'block';
		},
		
		hideNavRight : function() {
			if($('nav_right'))
				$('nav_right').style.display = 'none';
		},
		
		showLoaderImage : function() {
			if($('loader_icon'))
				$('loader_icon').style.display = 'block';
		},
		
		hideLoaderImage : function() {
			if($('loader_icon'))
				$('loader_icon').style.display = 'none';
		},
		
		showAutoFetch : function(id) {
			if($('af_content_' + id))
			{
				$('af_content_' + id).style.display = 'block';
				
				if(this.isListMode())
				{
					/* Theme specific change */
					if(browsr && browsr.screens[browsr.screen])
						this.hideRingsInAutoFetch(sindex, browsr.screens[browsr.screen].selector.count);
				}
			}
		},
		
		hideAutoFetch : function(id) {
			if($('af_content_' + id))
				$('af_content_' + id).style.display = 'none';
		},
		
		displayNoType : function(text) {
			if((text == null) || (text == undefined))
				text = '';
				
			var div = Helper.getRoundedContainer();
			var cnt = Helper.getRcContent(div);
			var p = Helper.getP(null, 'roundcont large center', text);
			cnt.appendChild(p);
			
			return div;
		},
		
		destroyDescendants : function(div) {
			if(div && div.hasChildNodes())
			{
				var child = div.firstChild;
				while(child)
				{
					this.destroyDescendants(child);
					var next_child = child.nextSibling;
					div.removeChild(child);
					child = next_child;
				}
			}
		},
		
		getKey : function(event) {
			if((event.keyCode == 38) || (event.charCode == 63497))
			{
				/* UP */
				return KEY_UP;
			}
			else if((event.keyCode == 40) || (event.charCode == 63498))
			{
				/* DOWN */
				return KEY_DOWN;
			}
			else if((event.keyCode == 37) || (event.charCode == 63495))
			{
				/* LEFT */
				return KEY_LEFT;
			}
			else if((event.keyCode == 39) || (event.charCode == 63496))
			{
				/* RIGHT */
				return KEY_RIGHT;
			}
			else if((event.keyCode == 0) || (event.charCode == 63557) || (event.keyCode == 13))
			{
				/* ENTER */
				return KEY_ENTER;
			}
			else if((event.keyCode == 8) || (event.charCode == 8))
			{
				/* C (cancel) */
				if(browsr && (!browsr.onion && (browsr.screen != SCREEN_MINI_VIEW)))
					goBack();
					
				return KEY_CANCEL;
			}
			else if(event.keyCode == 32)
			{
				/* SPACE BAR */
				if(browsr && (browsr.screen != SCREEN_MINI_VIEW))
					return KEY_SPACEBAR;
				else
					return null;
			}
		},
		
		getDiv : function(idx, classx) {
			var div = document.createElement('div');
			
			if(idx)
				div.setAttribute('id', idx);
				
			if(classx)
				div.setAttribute('class', classx);
				
			return div;
		},
		
		getImg : function(idx, classx, src) {
			var img = document.createElement('img');
			
			if(idx)
				img.setAttribute('id', idx);
			
			if(classx)
				img.setAttribute('class', classx);
				
			if(src)
				img.setAttribute('src', src);
				
			return img;
		},
		
		getP : function(idx, classx, text) {
			var p = document.createElement('p');
			
			if(idx)
				p.setAttribute('id', idx);
				
			if(classx)
				p.setAttribute('class', classx);
				
			if(text)
				p.appendChild(document.createTextNode(text));
				
			return p;
		},
		
		getBr : function() {
			return document.createElement('br');
		},
		
		getHr : function(classx) {
			var hr = document.createElement('hr');
			
			if(classx)
				hr.setAttribute('class', classx);
				
			return hr;
		},
		
		getCenter : function() {
			return document.createElement('center');
		},
		
		getUl : function(idx, classx) {
			var ul = document.createElement('ul');
			
			if(idx)
				ul.setAttribute('id', idx);
				
			if(classx)
				ul.setAttribute('class', classx);
				
			return ul;
		},
		
		getLi : function(idx, classx) {
			var li = document.createElement('li');
			
			if(idx)
				li.setAttribute('id', idx);
				
			if(classx)
				li.setAttribute('class', classx);
				
			return li;
		},
		
		getTextBox : function(idx, classx, size, maxlen, defval) {
			var input = document.createElement('input');
			input.setAttribute('type', 'text');
			
			if(idx)
				input.setAttribute('id', idx);
				
			if(classx)
				input.className = classx;
				
			if(size)
				input.setAttribute('size', size);
				
			if(maxlen)
				input.setAttribute('maxlength', maxlen);
				
			if(defval)
				input.setAttribute('value', defval);
				
			return input;
		},
		
		getCheckBox : function(idx, classx, defval) {
			var input = document.createElement('input');
			input.setAttribute('type', 'checkbox');
			
			if(idx)
				input.setAttribute('id', idx);
				
			if(classx)
				input.className = classx;
				
			if(defval)
				input.setAttribute('value', defval);
				
			return input;
		},
		
		getButton : function(idx, classx, value) {
			var input = document.createElement('input');
			input.setAttribute('type', 'button');
			
			if(idx)
				input.setAttribute('id', idx);
				
			if(classx)
				input.className = classx;
				
			if(value)
				input.setAttribute('value', value);
				
			return input;
		},
		
		getTable : function(idx, classx) {
			var table = document.createElement('table');
			
			if(idx)
				table.setAttribute('id', idx);
				
			if(classx)
				table.setAttribute('class', classx);
				
			return table;
		},
		
		getTr : function(idx, classx) {
			var tr = document.createElement('tr');
			
			if(idx)
				tr.setAttribute('id', idx);
				
			if(classx)
				tr.setAttribute('class', classx);
				
			return tr;
		},
		
		getTd : function(idx, classx) {
			var td = document.createElement('td');
			
			if(idx)
				td.setAttribute('id', idx);
				
			if(classx)
				td.setAttribute('class', classx);
				
			return td;
		},
		
		getDatePickerBox : function(text, iyear, imonth, iday, iok) {
			
			var p = Helper.getP(null, null, text);
			
			var dinput = Helper.getDiv(null, 'search');
			var dcont = Helper.getDiv(null, 'input');
			
			var today = new Date();
			var tyear = '' + today.getFullYear();
			var tmonth = today.getMonth()+1;
			var tday = today.getDate();
			
			if(tmonth < 10)
				tmonth = '0' + tmonth;
				
			if(tday < 10)
				tday = '0' + tday;
			
			var limage = Helper.getImg(null, null, './images/searchl.png');
			var year = Helper.getTextBox(iyear, 'searchinput', '4', '4', tyear);
			var month = Helper.getTextBox(imonth, 'searchinput', '2', '2', tmonth);
			var day = Helper.getTextBox(iday, 'searchinput', '2', '2', tday);
			var rbutton = Helper.getButton(iok, 'searchbutton', '');
			
			var dtable = Helper.getTable(null, null);
			var dtr = Helper.getTr(null, null);
			var dtd1 = Helper.getTd(null, null);
			var dtd2 = Helper.getTd(null, null);
			var dtd3 = Helper.getTd(null, null);
			var dtd4 = Helper.getTd(null, null);
			var dtd5 = Helper.getTd(null, null);
			
			dtd1.appendChild(limage);
			dtd2.appendChild(year);
			dtd3.appendChild(month);
			dtd4.appendChild(day);
			dtd5.appendChild(rbutton);
			dtr.appendChild(dtd1);
			dtr.appendChild(dtd2);
			dtr.appendChild(dtd3);
			dtr.appendChild(dtd4);
			dtr.appendChild(dtd5);
			dtable.appendChild(dtr);
			dcont.appendChild(dtable);
			
			dinput.appendChild(p);
			dinput.appendChild(dcont);
			
			return dinput;
		},
		
		getSearchBox : function(text, itext, iok) {
			
			var p = Helper.getP(null, null, text);
			
			var dinput = Helper.getDiv(null, 'search');
			var dcont = Helper.getDiv(null, 'input');
			
			var limage = Helper.getImg(null, null, './images/searchl.png');
			var ctext = Helper.getTextBox(itext, 'searchinput', '16', '', '');
			var rbutton = Helper.getButton(iok, 'searchbutton', '');
			
			var dtable = Helper.getTable(null, null);
			var dtr = Helper.getTr(null, null);
			var dtd1 = Helper.getTd(null, null);
			var dtd2 = Helper.getTd(null, null);
			var dtd3 = Helper.getTd(null, null);
			
			dtd1.appendChild(limage);
			dtd2.appendChild(ctext);
			dtd3.appendChild(rbutton);
			dtr.appendChild(dtd1);
			dtr.appendChild(dtd2);
			dtr.appendChild(dtd3);
			dtable.appendChild(dtr);
			dcont.appendChild(dtable);
			
			dinput.appendChild(p);
			dinput.appendChild(dcont);
			
			return dinput;
		},
		
		getAFExtraLargePhoto : function(photo_url) {
			var dimg = Helper.getDiv(null, 'gframe extralarge');
			var img = Helper.getImg(null, 'photo extralarge', photo_url);
			dimg.appendChild(img);
			return dimg;
		},
		
		getAFLargePhoto : function(photo_url) {
			var dimg = Helper.getDiv(null, 'gframe large');
			var img = Helper.getImg(null, 'photo large', photo_url);
			dimg.appendChild(img);
			return dimg;
		},
		
		getAFSmallPhoto : function(photo_url) {
			var dimg = Helper.getDiv(null, 'gframe small');
			var img = Helper.getImg(null, 'photo small', photo_url);
			dimg.appendChild(img);
			return dimg;
		},
		
		setAFPhoto : function(sindex, photo_url, photo_size) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(photo_url)
				{
					var img;
					if(photo_size == 'small')
						img = this.getAFSmallPhoto(photo_url);
					else if(photo_size == 'extralarge')
						img = this.getAFExtraLargePhoto(photo_url);
					else
						img = this.getAFLargePhoto(photo_url);
							
					$('autof_elt_' + sindex).appendChild(img);
				}
				
				this.showAutoFetch(sindex);
			} catch (e) { }
		},
		
		setAFPhotoList : function(sindex, photo_url, photo_size) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(photo_url)
				{
					for(var i=0; i<photo_url.length; i++)
					{
						var img;
						if(photo_size == 'small')
							img = this.getAFSmallPhoto(photo_url[i]);
						else if(photo_size == 'extralarge')
							img = this.getAFExtraLargePhoto(photo_url[i]);
						else
							img = this.getAFLargePhoto(photo_url[i]);
							
						$('autof_elt_' + sindex).appendChild(img);
					}
				}
				
				this.showAutoFetch(sindex);
			} catch (e) { }
		},
		
		getAFText : function(text) {
			if(text)
			{
				var ul = this.getUl(null, null);
				var p = this.getP(null, null, text);
				var li = this.getLi(null, null);
				
				li.appendChild(p);
				ul.appendChild(li);
				return ul;
			}
			
			return null;
		},
		
		getAFTextList : function(text) {
			if(text)
			{
				var ul = this.getUl(null, null);
				
				for(var i=0; i<text.length; i++)
				{
					var p = this.getP(null, null, text[i]);
					var li = this.getLi(null, null);
					li.appendChild(p);
					ul.appendChild(li);
				}
				
				return ul;
			}
			
			return null;
		},
		
		setAFText : function(sindex, text) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(text)
				{
					var ul = this.getAFText(text);
					
					if(ul)
						$('autof_elt_' + sindex).appendChild(ul);
				}
				
				this.showAutoFetch(sindex);
			} catch (e) { }
		},
		
		setAFTextList : function(sindex, text) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(text)
				{
					var ul = this.getAFTextList(text);
					
					if(ul)
					{
						$('autof_elt_' + sindex).appendChild(ul);
						this.showAutoFetch(sindex);
					}
				}
			} catch (e) {}
		},
		
		setAFTextListHeader : function(sindex, thead, tlist) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(thead)
				{
					var ul = this.getP(null, 'header', thead + ' :');
					if(ul)
						$('autof_elt_' + sindex).appendChild(ul);
				}
				
				if(tlist)
				{
					var ul = this.getUl(null, null);
					
					for(var i=0; i<tlist.length; i++)
					{
						var p;
						if( i < tlist.length-1)
							p = this.getP(null, null, tlist[i] + ',');
						else
							p = this.getP(null, null, tlist[i] + '.');
							
						var li = this.getLi(null, null);
						li.appendChild(p);
						ul.appendChild(li);
					}
					
					if(ul)
						$('autof_elt_' + sindex).appendChild(ul);
				}
				
				this.showAutoFetch(sindex);
			} catch (e) { }
		},
		
		setAFPhotoTextList : function(sindex, photo_url, text, photo_size, photo_direction) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(photo_url)
				{
					var img;
					if(photo_size == 'small')
						img = this.getAFSmallPhoto(photo_url);
					else if(photo_size == 'extralarge')
						img = this.getAFExtraLargePhoto(photo_url);
					else
						img = this.getAFLargePhoto(photo_url);
						
					if(photo_direction)
						img.className = img.className + ' ' + photo_direction;
					
					$('autof_elt_' + sindex).appendChild(img);
				}
				
				if(text)
				{
					var ul = this.getAFTextList(text);
					$('autof_elt_' + sindex).appendChild(ul);
				}
				
				this.showAutoFetch(sindex);
			} catch(e) { }
		},
		
		setAFTextPhotoList : function(sindex, photo_url, text, photo_size, photo_direction) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(text)
				{
					var ul = this.getAFText(text);
					$('autof_elt_' + sindex).appendChild(ul);
				}
				
				if(photo_url)
				{
					for(var i=0; i<photo_url.length; i++)
					{
						var img;
						if(photo_size == 'small')
							img = this.getAFSmallPhoto(photo_url[i]);
						else if(photo_size == 'extralarge')
							img = this.getAFExtraLargePhoto(photo_url[i]);
						else
							img = this.getAFLargePhoto(photo_url[i]);
							
						if(photo_direction)
							img.className = img.className + ' ' + photo_direction;
						
						$('autof_elt_' + sindex).appendChild(img);
					}
				}
				
				this.showAutoFetch(sindex);
			} catch (e) {}
		},
		
		setAFPhotoText : function(sindex, photo_url, text, photo_size, photo_direction) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(photo_url)
				{
					var img;
					if(photo_size == 'small')
						img = this.getAFSmallPhoto(photo_url);
					else if(photo_size == 'extralarge')
						img = this.getAFExtraLargePhoto(photo_url);
					else
						img = this.getAFLargePhoto(photo_url);
						
					if(photo_direction)
						img.className = img.className + ' ' + photo_direction;
					
					$('autof_elt_' + sindex).appendChild(img);
				}
				
				if(text)
				{
					var ul = this.getAFText(text);
					$('autof_elt_' + sindex).appendChild(ul);
				}
				
				this.showAutoFetch(sindex);
			} catch (e) {}
		},
		
		setAFNoResult : function(sindex, text) {
			try {
				Helper.destroyDescendants($('autof_elt_' + sindex));
				if(text)
				{
					var ul = this.getUl(null, null);
					var p = this.getP(null, null, text);
					var li = this.getLi(null, null);
					
					li.appendChild(p);
					ul.appendChild(li);
					$('autof_elt_' + sindex).appendChild(ul);
				}
				
				this.showAutoFetch(sindex);
			} catch (e) { }
		},
		
		getAFContainer : function(id) {
			var divAF = this.getDiv('af_content_' + id, 'af_content');
			var tableAF = this.getTable(null, null);
			
			/* Top row */
			var trAFUp = this.getTr(null, null);
			var tdEdgeUL = this.getTd(null, 'edge');
			var divEdgeUL = this.getDiv(null, 'up left');
			var tdMiddleUp = this.getTd(null, 'middle');
			var divMiddleUp = this.getDiv(null, 'up');
			var divUpRings = this.getDiv(null, 'rings');
			var imgUR1 = this.getImg(null, 'top', './images/ring_top.png');
			var imgUR2 = this.getImg(null, 'top', './images/ring_top.png');
			var imgUR3 = this.getImg(null, 'top', './images/ring_top.png');
			var imgDR1 = this.getImg(null, 'bottom', './images/ring_bottom.png');
			var imgDR2 = this.getImg(null, 'bottom', './images/ring_bottom.png');
			var imgDR3 = this.getImg(null, 'bottom', './images/ring_bottom.png');
			var tdEdgeUR = this.getTd(null, 'edge');
			var divEdgeUR = this.getDiv(null, 'up right');
			
			tdEdgeUL.appendChild(divEdgeUL);
			
			divUpRings.appendChild(imgUR1);
			divUpRings.appendChild(imgUR2);
			divUpRings.appendChild(imgUR3);
			divUpRings.appendChild(imgDR1);
			divUpRings.appendChild(imgDR2);
			divUpRings.appendChild(imgDR3);
			divMiddleUp.appendChild(divUpRings);
			tdMiddleUp.appendChild(divMiddleUp);
			
			tdEdgeUR.appendChild(divEdgeUR);
			
			trAFUp.appendChild(tdEdgeUL);
			trAFUp.appendChild(tdMiddleUp);
			trAFUp.appendChild(tdEdgeUR);
			
			/* Middle Row */
			var trAFMiddle = this.getTr('autof_elt_tr_' + id, null);
			var tdMiddleLeft = this.getTd(null, 'middle center left');
			var divCenterLeft = this.getDiv(null, null);
			var pSpace1 = this.getP(null, null, ' ');
			var tdMiddleMiddle = this.getTd(null, 'middle center');
			var divCenterMiddle = this.getDiv('autof_elt_' + id, 'af_area');
			//var pAFContent = this.getP(null, null, 'sriram');
			var tdMiddleRight = this.getTd(null, 'middle center right');
			var divCenterRight = this.getDiv(null, null);
			var pSpace2 = this.getP(null, null, ' ');
			
			divCenterLeft.appendChild(pSpace1);
			tdMiddleLeft.appendChild(divCenterLeft);
			
			//divCenterMiddle.appendChild(pAFContent);
			tdMiddleMiddle.appendChild(divCenterMiddle);
			
			divCenterRight.appendChild(pSpace2);
			tdMiddleRight.appendChild(divCenterRight);
			
			trAFMiddle.appendChild(tdMiddleLeft);
			trAFMiddle.appendChild(tdMiddleMiddle);
			trAFMiddle.appendChild(tdMiddleRight);
			
			/* Bottom row */
			var trAFDown = this.getTr(null, null);
			var tdEdgeDL = this.getTd(null, 'edge');
			var divEdgeDL = this.getDiv(null, 'down left');
			var tdMiddleDown = this.getTd(null, 'middle');
			var divMiddleDown = this.getDiv(null, 'down');
			var tdEdgeDR = this.getTd(null, 'edge');
			var divEdgeDR = this.getDiv(null, 'down right');
			
			tdEdgeDL.appendChild(divEdgeDL);
			tdMiddleDown.appendChild(divMiddleDown);
			tdEdgeDR.appendChild(divEdgeDR);
			
			trAFDown.appendChild(tdEdgeDL);
			trAFDown.appendChild(tdMiddleDown);
			trAFDown.appendChild(tdEdgeDR);
			
			tableAF.appendChild(trAFUp);
			tableAF.appendChild(trAFMiddle);
			tableAF.appendChild(trAFDown);
			divAF.appendChild(tableAF);
			
			divAF.style.display = 'none';
			
			return divAF;
		},
		
		getRoundedContainer : function(id) {
			var divAF = this.getDiv('af_content_' + id, 'af_content');
			var tableAF = this.getTable(null, null);
			
			/* Top row */
			var trAFUp = this.getTr(null, null);
			var tdEdgeUL = this.getTd(null, 'edge');
			var divEdgeUL = this.getDiv(null, 'up left');
			var tdMiddleUp = this.getTd(null, 'middle');
			var divMiddleUp = this.getDiv(null, 'up');
			var tdEdgeUR = this.getTd(null, 'edge');
			var divEdgeUR = this.getDiv(null, 'up right');
			
			tdEdgeUL.appendChild(divEdgeUL);
			tdMiddleUp.appendChild(divMiddleUp);
			tdEdgeUR.appendChild(divEdgeUR);
			
			trAFUp.appendChild(tdEdgeUL);
			trAFUp.appendChild(tdMiddleUp);
			trAFUp.appendChild(tdEdgeUR);
			
			/* Middle Row */
			var trAFMiddle = this.getTr('autof_elt_tr_' + id, null);
			var tdMiddleLeft = this.getTd(null, 'middle center left');
			var divCenterLeft = this.getDiv(null, null);
			var pSpace1 = this.getP(null, null, ' ');
			var tdMiddleMiddle = this.getTd(null, 'middle center');
			var divCenterMiddle = this.getDiv('af_content_' + id + '_area', 'af_area');
			//var pAFContent = this.getP(null, null, 'sriram');
			var tdMiddleRight = this.getTd(null, 'middle center right');
			var divCenterRight = this.getDiv(null, null);
			var pSpace2 = this.getP(null, null, ' ');
			
			divCenterLeft.appendChild(pSpace1);
			tdMiddleLeft.appendChild(divCenterLeft);
			
			//divCenterMiddle.appendChild(pAFContent);
			tdMiddleMiddle.appendChild(divCenterMiddle);
			
			divCenterRight.appendChild(pSpace2);
			tdMiddleRight.appendChild(divCenterRight);
			
			trAFMiddle.appendChild(tdMiddleLeft);
			trAFMiddle.appendChild(tdMiddleMiddle);
			trAFMiddle.appendChild(tdMiddleRight);
			
			/* Bottom row */
			var trAFDown = this.getTr(null, null);
			var tdEdgeDL = this.getTd(null, 'edge');
			var divEdgeDL = this.getDiv(null, 'down left');
			var tdMiddleDown = this.getTd(null, 'middle');
			var divMiddleDown = this.getDiv(null, 'down');
			var tdEdgeDR = this.getTd(null, 'edge');
			var divEdgeDR = this.getDiv(null, 'down right');
			
			tdEdgeDL.appendChild(divEdgeDL);
			tdMiddleDown.appendChild(divMiddleDown);
			tdEdgeDR.appendChild(divEdgeDR);
			
			trAFDown.appendChild(tdEdgeDL);
			trAFDown.appendChild(tdMiddleDown);
			trAFDown.appendChild(tdEdgeDR);
			
			tableAF.appendChild(trAFUp);
			tableAF.appendChild(trAFMiddle);
			tableAF.appendChild(trAFDown);
			divAF.appendChild(tableAF);
			
			divAF.style.display = 'block';
			divAF.rcContent = divCenterMiddle;
			divAF.style.margin = '20px 10px 20px 10px';
			
			return divAF;
		},
		
		getCommentContainer : function(id) {
			var divAF = this.getDiv('comment_' + id, 'comment');
			var tableAF = this.getTable(null, null);
			
			/* Top row */
			var trAFUp = this.getTr(null, null);
			var tdEdgeUL = this.getTd(null, 'edge');
			var divEdgeUL = this.getDiv(null, 'up left');
			var tdMiddleUp = this.getTd(null, 'middle');
			var divMiddleUp = this.getDiv(null, 'up');
			var tdEdgeUR = this.getTd(null, 'edge');
			var divEdgeUR = this.getDiv(null, 'up right');
			
			tdEdgeUL.appendChild(divEdgeUL);
			tdMiddleUp.appendChild(divMiddleUp);
			tdEdgeUR.appendChild(divEdgeUR);
			
			trAFUp.appendChild(tdEdgeUL);
			trAFUp.appendChild(tdMiddleUp);
			trAFUp.appendChild(tdEdgeUR);
			
			/* Middle Row */
			var trAFMiddle = this.getTr('autof_elt_tr_' + id, null);
			var tdMiddleLeft = this.getTd(null, 'middle center left');
			var divCenterLeft = this.getDiv(null, null);
			var pSpace1 = this.getP(null, null, ' ');
			var tdMiddleMiddle = this.getTd(null, 'middle center');
			var divCenterMiddle = this.getDiv('autof_elt_' + id, 'af_area');
			var tdMiddleRight = this.getTd(null, 'middle center right');
			var divCenterRight = this.getDiv(null, null);
			var pSpace2 = this.getP(null, null, ' ');
			
			divCenterLeft.appendChild(pSpace1);
			tdMiddleLeft.appendChild(divCenterLeft);
			
			tdMiddleMiddle.appendChild(divCenterMiddle);
			
			divCenterRight.appendChild(pSpace2);
			tdMiddleRight.appendChild(divCenterRight);
			
			trAFMiddle.appendChild(tdMiddleLeft);
			trAFMiddle.appendChild(tdMiddleMiddle);
			trAFMiddle.appendChild(tdMiddleRight);
			
			/* Bottom row */
			var trAFDown = this.getTr(null, null);
			var tdEdgeDL = this.getTd(null, 'edge');
			var divEdgeDL = this.getDiv(null, 'down left');
			var tdMiddleDown = this.getTd(null, 'middle');
			var divMiddleDown = this.getDiv(null, 'down');
			var tdEdgeDR = this.getTd(null, 'edge');
			var divEdgeDR = this.getDiv(null, 'down right');
			
			tdEdgeDL.appendChild(divEdgeDL);
			tdMiddleDown.appendChild(divMiddleDown);
			tdEdgeDR.appendChild(divEdgeDR);
			
			trAFDown.appendChild(tdEdgeDL);
			trAFDown.appendChild(tdMiddleDown);
			trAFDown.appendChild(tdEdgeDR);
			
			tableAF.appendChild(trAFUp);
			tableAF.appendChild(trAFMiddle);
			tableAF.appendChild(trAFDown);
			divAF.appendChild(tableAF);
			
			divAF.style.display = 'block';
			divAF.comContent = divCenterMiddle;
			
			return divAF;
		},
		
		getDescriptionContainer : function(id) {
			var divAF = this.getDiv('description_' + id, 'af_content');
			var tableAF = this.getTable(null, null);
			
			/* Top row */
			var trAFUp = this.getTr(null, null);
			var tdEdgeUL = this.getTd(null, 'edge');
			var divEdgeUL = this.getDiv(null, 'up left');
			var tdMiddleUp = this.getTd(null, 'middle');
			var divMiddleUp = this.getDiv(null, 'up');
			var tdEdgeUR = this.getTd(null, 'edge');
			var divEdgeUR = this.getDiv(null, 'up right');
			
			tdEdgeUL.appendChild(divEdgeUL);
			tdMiddleUp.appendChild(divMiddleUp);
			tdEdgeUR.appendChild(divEdgeUR);
			
			trAFUp.appendChild(tdEdgeUL);
			trAFUp.appendChild(tdMiddleUp);
			trAFUp.appendChild(tdEdgeUR);
			
			/* Middle Row */
			var trAFMiddle = this.getTr('autof_elt_tr_' + id, null);
			var tdMiddleLeft = this.getTd(null, 'middle center left');
			var divCenterLeft = this.getDiv(null, null);
			var pSpace1 = this.getP(null, null, ' ');
			var tdMiddleMiddle = this.getTd(null, 'middle center');
			var divCenterMiddle = this.getDiv('autof_elt_' + id, 'af_area');
			var tdMiddleRight = this.getTd(null, 'middle center right');
			var divCenterRight = this.getDiv(null, null);
			var pSpace2 = this.getP(null, null, ' ');
			
			divCenterLeft.appendChild(pSpace1);
			tdMiddleLeft.appendChild(divCenterLeft);
			
			tdMiddleMiddle.appendChild(divCenterMiddle);
			
			divCenterRight.appendChild(pSpace2);
			tdMiddleRight.appendChild(divCenterRight);
			
			trAFMiddle.appendChild(tdMiddleLeft);
			trAFMiddle.appendChild(tdMiddleMiddle);
			trAFMiddle.appendChild(tdMiddleRight);
			
			/* Bottom row */
			var trAFDown = this.getTr(null, null);
			var tdEdgeDL = this.getTd(null, 'edge');
			var divEdgeDL = this.getDiv(null, 'down left');
			var tdMiddleDown = this.getTd(null, 'middle');
			var divMiddleDown = this.getDiv(null, 'down');
			var tdEdgeDR = this.getTd(null, 'edge');
			var divEdgeDR = this.getDiv(null, 'down right');
			
			tdEdgeDL.appendChild(divEdgeDL);
			tdMiddleDown.appendChild(divMiddleDown);
			tdEdgeDR.appendChild(divEdgeDR);
			
			trAFDown.appendChild(tdEdgeDL);
			trAFDown.appendChild(tdMiddleDown);
			trAFDown.appendChild(tdEdgeDR);
			
			tableAF.appendChild(trAFUp);
			tableAF.appendChild(trAFMiddle);
			tableAF.appendChild(trAFDown);
			divAF.appendChild(tableAF);
			
			divAF.style.display = 'block';
			divAF.descContent = divCenterMiddle;
			
			return divAF;
		},
		
		getMiniContainer : function() {
			var divAF = this.getDiv('mini_cont', 'mini');
			var tableAF = this.getTable(null, null);
			
			/* Middle Row */
			var trAFMiddle = this.getTr(null, null);
			var tdMiddleLeft = this.getTd(null, 'middle center left');
			var divCenterLeft = this.getDiv(null, null);
			var pSpace1 = this.getP(null, null, ' ');
			var tdMiddleMiddle = this.getTd(null, 'middle center');
			var divCenterMiddle = this.getDiv('mini_area', 'mini_area');
			//var pAFContent = this.getP(null, null, 'sriram');
			var tdMiddleRight = this.getTd(null, 'middle center right');
			var divCenterRight = this.getDiv(null, null);
			var pSpace2 = this.getP(null, null, ' ');
			
			divCenterLeft.appendChild(pSpace1);
			tdMiddleLeft.appendChild(divCenterLeft);
			
			//divCenterMiddle.appendChild(pAFContent);
			tdMiddleMiddle.appendChild(divCenterMiddle);
			
			divCenterRight.appendChild(pSpace2);
			tdMiddleRight.appendChild(divCenterRight);
			
			trAFMiddle.appendChild(tdMiddleLeft);
			trAFMiddle.appendChild(tdMiddleMiddle);
			trAFMiddle.appendChild(tdMiddleRight);
			
			/* Bottom row */
			var trAFDown = this.getTr(null, null);
			var tdEdgeDL = this.getTd(null, 'edge');
			var divEdgeDL = this.getDiv(null, 'down left');
			var tdMiddleDown = this.getTd(null, 'middle');
			var divMiddleDown = this.getDiv(null, 'down');
			var tdEdgeDR = this.getTd(null, 'edge');
			var divEdgeDR = this.getDiv(null, 'down right');
			
			tdEdgeDL.appendChild(divEdgeDL);
			tdMiddleDown.appendChild(divMiddleDown);
			tdEdgeDR.appendChild(divEdgeDR);
			
			trAFDown.appendChild(tdEdgeDL);
			trAFDown.appendChild(tdMiddleDown);
			trAFDown.appendChild(tdEdgeDR);
			
			tableAF.appendChild(trAFMiddle);
			tableAF.appendChild(trAFDown);
			divAF.appendChild(tableAF);
			
			return divAF;
		},
		
		getOnionContainer : function(id) {
			return this.getRoundedContainer(id);
		},
		
		getOnionSkin : function(id) {
			var div = Helper.getDiv(id, 'onionskin');
			div.style.height = $('content_area').clientHeight;
			
			return div;
		},
		
		getPhotoframe : function(photo_url, size, tnote) {
			var div = Helper.getDiv('photo_cont', null);
			var center = Helper.getCenter();
			
			var divPframe;
			switch(browsr.frame)
			{
				case FRAME_NONE:
					divPframe = Helper.getDiv('photoframe', 'noborder');
					break;
					
				case FRAME_WHITE:
					divPframe = Helper.getDiv('photoframe', 'frame white');
					break;
					
				case FRAME_BLACK:
					divPframe = Helper.getDiv('photoframe', 'frame black');
					break;
					
				case FRAME_POLAROID:
					divPframe = Helper.getDiv('photoframe', 'frame polaroid');
					break;
			}
			
			var tablePframe = Helper.getTable(null, null);
			
			var trUp  = Helper.getTr(null, null);
			var tdUL  = Helper.getTd(null, 'edge');
			var divUL = Helper.getDiv(null, 'up left');
			var tdUM  = Helper.getTd(null, 'middle');
			var divUM = Helper.getDiv(null, 'up');
			var tdUR  = Helper.getTd(null, 'edge');
			var divUR = Helper.getDiv(null, 'up right');
			
			var trMiddle = Helper.getTr (null, null);
			var tdML     = Helper.getTd (null, 'middle left');
			var divML    = Helper.getDiv(null, null);
			var tdMM     = Helper.getTd (null, 'middle');
			var divMM    = Helper.getDiv('photo_div', 'center');
			var img      = Helper.getImg('photo', null, photo_url);
			var tdMR     = Helper.getTd (null, 'middle right');
			var divMR    = Helper.getDiv(null, null);
			
			var trDown = Helper.getTr (null, null);
			var tdDL   = Helper.getTd (null, 'edge');
			var divDL  = Helper.getDiv(null, 'down left');
			var tdDM   = Helper.getTd (null, 'middle');
			var divDM  = Helper.getDiv(null, 'down');
			var tdDR   = Helper.getTd (null, 'edge');
			var divDR  = Helper.getDiv(null, 'down right');
			
			img.addEventListener('load', function() {
														divPframe.style.display = 'block';
														var h = img.clientHeight;
														var w = img.clientWidth;
														
														if(size)
															Helper.resizePhotoframe(divMM, img, size);
															
														if(size || (h < 200))
														{
															Helper.placeInCenter(divPframe, div);
															Helper.placeInCenter(div, $('content_area'));
															
															if(tnote)
															{
																var dnote = Helper.getDiv('picnote', 'notesdiv');
																
																var top, left, height, width;
																var const_top, const_left;
																
																const_top = ($('content_area').clientHeight - img.clientHeight) / 2;
																const_left = ($('content_area').clientWidth - img.clientWidth) / 2;
																
																top = (parseInt(tnote[0]) * img.clientHeight) / h;
																left = (parseInt(tnote[1]) * img.clientWidth) / w;
																height = (parseInt(tnote[2]) * img.clientHeight) / h;
																width = (parseInt(tnote[3]) * img.clientWidth) / w;
																
																dnote.style.top = (top + const_top)+ 'px';
																dnote.style.left = (left + const_left) + 'px';
																dnote.style.height = height + 'px';
																dnote.style.width = width + 'px';
																
																div.appendChild(dnote);
															}
														}
														
														/* Ideally this shud be div.clientWidth */
														var w_div = divMM.clientWidth; 
														
														if(w_div >= 240)
														{
															/* Making up for the border width*/
															sphoto.scroll.scrollarea.style.width = (w_div + 10)+ 'px';
														}
														
														sphoto.resize();
														sphoto.scroll.updateScrollbar();
													}, false);
			
			tdUL.appendChild(divUL);
			tdUM.appendChild(divUM);
			tdUR.appendChild(divUR);
			trUp.appendChild(tdUL);
			trUp.appendChild(tdUM);
			trUp.appendChild(tdUR);
			
			divMM.appendChild(img);
			tdML.appendChild(divML);
			tdMM.appendChild(divMM);
			tdMR.appendChild(divMR);
			trMiddle.appendChild(tdML);
			trMiddle.appendChild(tdMM);
			trMiddle.appendChild(tdMR);
			
			tdDL.appendChild(divDL);
			tdDM.appendChild(divDM);
			tdDR.appendChild(divDR);
			trDown.appendChild(tdDL);
			trDown.appendChild(tdDM);
			trDown.appendChild(tdDR);
			
			tablePframe.appendChild(trUp);
			tablePframe.appendChild(trMiddle);
			tablePframe.appendChild(trDown);
			
			divPframe.appendChild(tablePframe);
			divPframe.style.display = 'none';
			
			center.appendChild(divPframe);
			div.appendChild(center);
			div.photoDiv = divMM;
			div.photo = img;
			
			return div;
		},
		
		getPhotoInFrame : function(div) {
			if(div)
			{
				return div.photoDiv;
			}
			return null;
		},
		
		getRcContent : function(div) {
			if(div)
				return div.rcContent;
			else	
				return null;
		},
		
		getCommentContent : function(div) {
			if(div)
				return div.comContent;
			else	
				return null;
		},
		
		getDescriptionContent : function(div) {
			if(div)
				return div.descContent;
			else	
				return null;
		},
		
		getOnionContent : function(div) {
			return this.getRcContent(div);
		},
		
		hideIconGloss : function(id) {
			if($('highlight_' + id))
				$('highlight_' + id).image_available = false;
				
			if($('gloss_' + id))
				$('gloss_' + id).style.display = 'none';
		},
		
		hideIconGlossSet : function(count) {
			for(var i=0; i < count; i++)
				this.hideIconGloss(i);
		},
		
		showIconGloss : function(id) {
			if($('highlight_' + id))
				$('highlight_' + id).image_available = true;
				
			if($('gloss_' + id))
				$('gloss_' + id).style.display = '';
		},
		
		showIconGlossSet : function(count) {
			for(var i=0; i < count; i++)
				this.showIconGloss(i);
		},
		
		showRingsInAutoFetch : function(index, count) {
		
			$('list_el_rl_d_' + index).style.display = 'block';
			$('list_el_rr_d_' + index).style.display = 'block';
		
			if(index < (count - 1))
			{
				$('list_el_rl_u_' + (index + 1)).style.display = 'block';
				$('list_el_rr_u_' + (index + 1)).style.display = 'block';
			}
		},
		
		hideRingsInAutoFetch : function(index, count) {
		
			$('list_el_rl_d_' + index).style.display = 'none';
			$('list_el_rr_d_' + index).style.display = 'none';
			
			if(index < (count - 1))
			{
				$('list_el_rl_u_' + (index + 1)).style.display = 'none';
				$('list_el_rr_u_' + (index + 1)).style.display = 'none';
			}
		},
		
		initialize : function(tscreen) {
			if(this.isListMode())
			{
				/*
				this.showTitlebar();
				this.hideNavbar();
				*/
				
				tscreen.scroll = new Scroll();		
				/* adding to the parent div */
				tscreen.scroll.addTo('content_area');
				$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
				$('scrollpanel').style.height	= (200 - 5) + 'px';
				
				/*
				$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
				$('hscrollpanel').style.width	= (240 - 5) + 'px';
				*/
				
				tscreen.div = $('content_area');
				tscreen.div.style.display = 'block';
				
				tscreen.selector = new Selector();
				/* adding to scrollable area */
				tscreen.scroll.add(tscreen.selector.div);
				tscreen.selector.scroll = tscreen.scroll;
			}
			else
			{	
				tscreen.scroll = new Scroll();		
				/* adding to the parent div */
				tscreen.scroll.addTo('content_area');
				$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
				$('scrollpanel').style.height	= (200 - 5) + 'px';
				
				/*
				$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
				$('hscrollpanel').style.width	= (240 - 5) + 'px';
				*/
				
				tscreen.div = $('content_area');
				tscreen.div.style.display = 'block';
				
				tscreen.tabs = new Tabs();
				/* adding to scrollable area */
				tscreen.scroll.add(tscreen.tabs.div);
				tscreen.tabs.scroll = tscreen.scroll;
			}
			
			/* Post processing */
			this.setNavigator('...');
			this.hideNavLeft();
			this.hideNavRight();
		},
		
		initTabber : function(tscreen) {
			if(tscreen.elements)
			{
				tscreen.tabber = new Tabber();
				var tabber_array = [];
				for(var i=0; i < tscreen.elements.length; i++)
				{
					tabber_array[i] = new TabberItem(tscreen.elements[i].name, tscreen.elements[i].img, tscreen.elements[i].img);
				}
				
				tscreen.tabber.addArray(tabber_array);
			}
		},
		
		destroy : function(tscreen) {
			clearTimeout(tscreen.auto_disp_tid);
			tscreen.auto_disp_tid = 0;
			
			if(this.isListMode())
			{
				if(tscreen.selector)
					tscreen.selector.removeAll();
			}
			else
			{
				if(tscreen.tabs)
					tscreen.tabs.removeAll();
			}
				
			/* tscreen.div is content_area :D */
			this.destroyDescendants(tscreen.div);
			tscreen.selector = null;
			tscreen.tabs = null;
			tscreen.scroll = null;
			tscreen.tabber = null;
			/*tscreen.div.style.display = 'none';*/
		},
		
		displayList : function(tscreen) {
			
			for(var i=0; i<tscreen.elements.length; i++)
			{
				tscreen.selector.addElement(tscreen.elements[i].name, tscreen.elements[i].img, 'icon');
			}
			
			tscreen.selector.select(tscreen.lindex % MAX_LIST_SIZE);
			tscreen.tabber.select(tscreen.lindex % MAX_LIST_SIZE);
			
			tscreen.resize();
			tscreen.scroll.updateScrollbar();
		},
		
		displayTab : function(tscreen, subtitle) {
			if(!this.isListMode())
			{
				var sindex = tscreen.lindex;
				tscreen.tabs.addElement(sindex, tscreen.elements[sindex].name, subtitle, tscreen.elements[sindex].img, 'icon');
				tscreen.tabber.select(sindex);
				
				tscreen.resize();
				tscreen.scroll.updateScrollbar();
			}
		},
 		
		displayTabPage : function(tscreen, id, title, subtitle, img, img_type) {
			if(!this.isListMode())
			{
				if(img == null)
					img = defaultImage;
				
				var sindex = tscreen.lindex;
				if(img_type == 'icon')
				{
					tscreen.tabs.addElement(sindex, title, subtitle, img, 'icon');
				}
				else if(img_type == 'photoframe')
				{
					tscreen.tabs.addElement(sindex, title, subtitle, img, 'photoframe');
				}
				else
				{
					tscreen.tabs.addElement(sindex, title, subtitle, img, 'contactframe');
				}
				
				tscreen.resize();
				tscreen.scroll.updateScrollbar();
			}
		},
		
		keyUpList : function(tscreen) {
			if(tscreen.selector)
			{
				if((tscreen.selector.selected_index - 1) >= 0 )
				{
					tscreen.selector.select(tscreen.selector.selected_index - 1);
				}
				else
				{
					tscreen.selector.select(tscreen.selector.count - 1);
				}
				
				tscreen.tabber.select(tscreen.selector.selected_index);
			}
		},
		
		keyDownList : function(tscreen) {
			if(tscreen.selector)
			{	
				if((tscreen.selector.selected_index + 1) < tscreen.selector.count)
				{
					tscreen.selector.select(tscreen.selector.selected_index + 1);
				}
				else
				{
					tscreen.selector.select(0);
				}
				
				tscreen.tabber.select(tscreen.selector.selected_index);
			}
		},
		
		keySelectList : function(tscreen, index) {
			if(tscreen.selector)
			{
				tscreen.selector.select(index);
			}
		},
		
		keyUpListNav : function(tscreen) {
			if(tscreen.selector)
			{
				if((tscreen.selector.selected_index - 1) >= 0 )
				{
					tscreen.selector.select(tscreen.selector.selected_index - 1);
				}
				else
				{
					tscreen.selector.select(tscreen.selector.count - 1);
				}
				Helper.showNavbar();
				tscreen.updateNavigator();
			}
		},
		
		keyDownListNav : function(tscreen) {
			if(tscreen.selector)
			{
				if((tscreen.selector.selected_index + 1) < tscreen.selector.count)
				{
					tscreen.selector.select(tscreen.selector.selected_index + 1);
				}
				else
				{
					tscreen.selector.select(0);
				}
				Helper.showNavbar();
				tscreen.updateNavigator();
			}
		},
		
		keyLeftList : function(tscreen) {
			if(tscreen.total)
			{
				if((tscreen.cur_page - 1) >= 1)
				{
					flickr.purge_all();
					tscreen.lindex = 0;
					tscreen.cur_page = tscreen.cur_page - 1;
					tscreen.refresh();
				}
			}
		},
		
		keyRightList : function(tscreen) {
			if(tscreen.total)
			{
				if((tscreen.cur_page + 1) <= tscreen.pages)
				{
					flickr.purge_all();
					tscreen.lindex = 0;
					tscreen.cur_page = tscreen.cur_page + 1;
					tscreen.refresh();
				}
			}
		},
		
		keyUpScroll : function(tscreen) {
			if(tscreen.scroll)
			{
				if(tscreen.scroll.scrollarea.clientHeight > tscreen.scroll.scroll.clientHeight)
					tscreen.scroll.scrollUp(20);
			}
		},
		
		keyDownScroll : function(tscreen) {
			if(tscreen.scroll)
			{
				if(tscreen.scroll.scrollarea.clientHeight > tscreen.scroll.scroll.clientHeight)
					tscreen.scroll.scrollDown(20);
			}
		},
		
		keyLeftScroll : function(tscreen) {
			if(tscreen.scroll)
			{
				if(tscreen.scroll.scrollarea.clientWidth > tscreen.scroll.scroll.clientWidth)
					tscreen.scroll.scrollLeft(20);
			}
		},
		
		keyRightScroll : function(tscreen) {
			if(tscreen.scroll)
			{
				if(tscreen.scroll.scrollarea.clientWidth > tscreen.scroll.scroll.clientWidth)
					tscreen.scroll.scrollRight(20);
			}
		},
		
		keyLeftTab : function(tscreen) {
			tscreen.tabs.removeAll();
			if((tscreen.lindex - 1) >= 0)
			{
				tscreen.lindex = tscreen.lindex - 1;
				tscreen.displayTab();
			}
			else
			{
				tscreen.lindex = tscreen.elements.length - 1;
				tscreen.displayTab();
			}
		},
		
		keyRightTab : function(tscreen) {
			tscreen.tabs.removeAll();
			if((tscreen.lindex + 1) < tscreen.elements.length)
			{
				tscreen.lindex = tscreen.lindex + 1;
				tscreen.displayTab();
			}
			else
			{
				tscreen.lindex = 0;
				tscreen.displayTab();
			}
		},
		
		keyLeftTabPage : function(tscreen) {
			if(tscreen.total)
			{
				if((tscreen.lindex - 1) >= 0)
				{
					tscreen.lindex = tscreen.lindex - 1;
					tscreen.cur_page = parseInt(tscreen.lindex / MAX_LIST_SIZE) + 1;
					tscreen.refresh();
				}
			}
		},
		
		keyRightTabPage : function(tscreen) {
			if(tscreen.total)
			{
				if((tscreen.lindex + 1) <= (tscreen.total-1))
				{
					tscreen.lindex = tscreen.lindex + 1;
					tscreen.cur_page = parseInt(tscreen.lindex / MAX_LIST_SIZE) + 1;
					tscreen.refresh();
				}
			}
		},
		
		keySelectTab : function(tscreen, index) {
			tscreen.tabs.removeAll();
			tscreen.lindex = index;
			tscreen.displayTab();
		},
		
		getSindex : function(tscreen) {
			if(this.isListMode() && tscreen.selector)
				return tscreen.selector.selected_index;
			else
				return tscreen.lindex;
		},
		
		switchToTabs : function(tscreen) {	
			if(!(this.isListMode()))
			{
				var sindex = 0;
				if(tscreen.selector)
				{
					sindex = tscreen.selector.selected_index;
					tscreen.selector.removeAll();
					tscreen.selector = null;
				}
				
				flickr.purge_all();
				this.destroy(tscreen);
				this.initialize(tscreen);
				this.initTabber(tscreen);
				
				if(isNokia)
				{
					wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
					wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
				}
				else
				{
					toolbar.hide(MENU_SWITCH_TO_TABS.id);
					toolbar.show(MENU_SWITCH_TO_LIST.id);
				}
				
				tscreen.lindex = sindex;
				tscreen.displayTab();
				this.hideNavbar();
				this.showTabbar();
			}
		},
		
		switchToList : function(tscreen) {
			if(this.isListMode())
			{	
				if(tscreen.tabs)
				{
					tscreen.tabs.removeAll();
					tscreen.tabs = null;
				}
				
				flickr.purge_all();
				this.destroy(tscreen);
				this.initialize(tscreen);
				this.initTabber(tscreen);
				
				if(isNokia)
				{
					wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
					wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
				}
				else
				{
					toolbar.show(MENU_SWITCH_TO_TABS.id);
					toolbar.hide(MENU_SWITCH_TO_LIST.id);
				}
				
				tscreen.displayList();
				this.hideNavbar();
				this.showTabbar();
			}
		},
		
		switchToTabsPage : function(tscreen) {
			if(!this.isListMode())
			{
				var sindex = 0;
				if(tscreen.selector)
				{
					sindex = ((tscreen.cur_page - 1) * MAX_LIST_SIZE) + tscreen.selector.selected_index;
					tscreen.selector.removeAll();
					tscreen.selector = null;
				}
				
				flickr.purge_all();
				this.destroy(tscreen);
				this.initialize(tscreen);
				
				if(isNokia)
				{
					wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
					wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
				}
				else
				{
					toolbar.hide(MENU_SWITCH_TO_TABS.id);
					toolbar.show(MENU_SWITCH_TO_LIST.id);
				}
				
				tscreen.lindex = sindex;
				this.showNavbar();
				this.hideTabbar();
			}
		},
		
		switchToListPage : function(tscreen) {
			if(this.isListMode())
			{
				if(tscreen.tabs)
				{
					tscreen.tabs.removeAll();
					tscreen.tabs = null;
				}
				
				flickr.purge_all();
				this.destroy(tscreen);
				this.initialize(tscreen);
				
				if(isNokia)
				{
					wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
					wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
				}
				else
				{
					toolbar.show(MENU_SWITCH_TO_TABS.id);
					toolbar.hide(MENU_SWITCH_TO_LIST.id);
				}
				
				tscreen.cur_page = parseInt(tscreen.lindex / MAX_LIST_SIZE) + 1;
				this.showNavbar();
				this.hideTabbar();
			}
		},
		
		postDisplayList : function(tscreen) {
			if(tscreen.selector.count > 0)
			{
				tscreen.selector.select(tscreen.lindex % MAX_LIST_SIZE);
				tscreen.lindex = 0;
				this.showNavbar();
				tscreen.updateNavigator();
				tscreen.resize();
				tscreen.scroll.updateScrollbar();
				tscreen.updateMenus();
			}
		},
		
		postDisplayTabs : function(tscreen) {
			this.showNavbar();
			tscreen.updateNavigator();
			tscreen.resize();
			tscreen.scroll.updateScrollbar();
			tscreen.updateMenus();
		},
		
		selectedListItem : function(tscreen) {
			if(this.isListMode())
				return ((tscreen.cur_page - 1) * MAX_LIST_SIZE) + tscreen.selector.selected_index;
			else
				return tscreen.lindex;
		},
		
		updateNavigator : function(tscreen) {
			this.setNavigator('' + (tscreen.selectedListItem() + 1) + ' / ' + tscreen.total);
			
			if(this.isListMode())
			{
				if(tscreen.cur_page < tscreen.pages)
					this.showNavRight();
				else
					this.hideNavRight();
				
				if(tscreen.cur_page > 1)
					this.showNavLeft();
				else
					this.hideNavLeft();
			}
			else
			{
				if(tscreen.lindex > 0)
					this.showNavLeft();
				else
					this.hideNavLeft();
					
				if(tscreen.lindex < (tscreen.total-1))
					this.showNavRight();
				else
					this.hideNavRight();
			}
		},
		
		resizePhotoframe : function(div, img, maxSize) {
			if(div && img)
			{
				var h = img.height;
				var w = img.width;
				var origSize = (h > w) ? h : w;
				
				img.style.height = (h * maxSize / origSize) + 'px';
				img.style.width = (w * maxSize / origSize) + 'px';
				img.style.display = '';
				
				this.placeInCenter(img, div);
			}
		},
		
		placeInCenter : function(child, parent)
		{
			if(child && parent)
			{
				var child_h = child.clientHeight;
				var parent_h = parent.clientHeight;
				
				if(parent_h > child_h)
				{
					var amount = ((parent_h - child_h) / 2) + 'px';
				
					child.style.marginTop = '' + amount;
					child.style.marginBottom = '' + amount;
				}
			}
		},
		
		checkEllipsis : function(p, maxWidth, maxHeight) {
			if(p && p.origText)
			{				
				var len = p.origText.length;
				
				while((p.clientHeight > maxHeight) || (p.clientWidth > maxWidth))
				{
					/* Introduce Ellipsis */
					p.innerHTML = '' + p.origText.substr(0, len) + '...';
					len -= 1;
				}
			}
		},
		
		destroyCurrentScreen : function() {
			if(browsr && browsr.screens[browsr.screen])
				browsr.screens[browsr.screen].destroy();
		}
	}
	
	
	
	
	
	