/* Tab item name, id, and pic to be used in different views */
	function TabItem(name, img) {
		this.name = name;
		this.img = img;
	}
	
	
	/* Tabs for home */
	var tabs_home = [];
	
	tabs_home[HOME_IDX_PHOTOSTREAM]     = new TabItem('Photostream',     photostreamImage);
	tabs_home[HOME_IDX_CONTACTS]        = new TabItem('Contacts',        contactsImage);
	tabs_home[HOME_IDX_SETS]            = new TabItem('Sets',            setsImage);
	tabs_home[HOME_IDX_COLLECTIONS]     = new TabItem('Collections',     collectionsImage);
	tabs_home[HOME_IDX_TAGS]            = new TabItem('Tags',            tagsImage);
	tabs_home[HOME_IDX_FAVORITES]       = new TabItem('Favorites',       favoritesImage);
	tabs_home[HOME_IDX_PROFILE]         = new TabItem('Profile',         profileImage);
	tabs_home[HOME_IDX_RECENT_ACTIVITY] = new TabItem('Recent Activity', recentActivityImage);
	tabs_home[HOME_IDX_BOOKMARKS]       = new TabItem('Bookmarks',       bookmarksImage);
	tabs_home[HOME_IDX_SEARCH]          = new TabItem('Search',          searchImage);
	tabs_home[HOME_IDX_EXPLORE]         = new TabItem('Explore',         exploreImage);
	
	/* Tabs for photo */
	var tabs_photo = [];
	
	tabs_photo[PHOTO_IDX_PHOTO]       = new TabItem('Photo',       photoImage);
	tabs_photo[PHOTO_IDX_DESCRIPTION] = new TabItem('Description', descriptionImage);
	tabs_photo[PHOTO_IDX_COMMENTS]    = new TabItem('Comments',    commentsImage);
	tabs_photo[PHOTO_IDX_FAVORITES]   = new TabItem('Favorites',   favoritesImage);
	tabs_photo[PHOTO_IDX_TAGS]        = new TabItem('Tags',        tagsImage);
	tabs_photo[PHOTO_IDX_SETS]        = new TabItem('Sets',        setsImage);
	tabs_photo[PHOTO_IDX_NOTES]       = new TabItem('Notes',       notesImage);
	tabs_photo[PHOTO_IDX_EXIF]        = new TabItem('Exif',        exifImage);
	tabs_photo[PHOTO_IDX_SIZES]       = new TabItem('Sizes',       sizesImage);
	tabs_photo[PHOTO_IDX_OWNER]       = new TabItem('Owner',       ownerImage);
	
	/* Tabs for contact */
	var tabs_contact = [];
	
	tabs_contact[CONTACT_IDX_PHOTOSTREAM] = new TabItem('Photostream', photostreamImage);
	tabs_contact[CONTACT_IDX_CONTACTS]    = new TabItem('Contacts',    contactsImage);
	tabs_contact[CONTACT_IDX_SETS]        = new TabItem('Sets',        setsImage);
	tabs_contact[CONTACT_IDX_COLLECTIONS] = new TabItem('Collections', collectionsImage);
	tabs_contact[CONTACT_IDX_TAGS]        = new TabItem('Tags',        tagsImage);
	tabs_contact[CONTACT_IDX_FAVORITES]   = new TabItem('Favorites',   favoritesImage);
	tabs_contact[CONTACT_IDX_PROFILE]     = new TabItem('Profile',     profileImage);
	
	
	/* Tabs for set */
	var tabs_set = [];
	
	tabs_set[SET_IDX_PHOTOS]      = new TabItem('Photos',      photosImage);
	tabs_set[SET_IDX_DESCRIPTION] = new TabItem('Description', descriptionImage);
	tabs_set[SET_IDX_COMMENTS]    = new TabItem('Comments',    commentsImage);
	
	
	/* Tabs for collection */
	var tabs_collection = [];
	
	tabs_collection[COLLECTION_IDX_ITEMS] 		= new TabItem('Items',       itemsImage);
	tabs_collection[COLLECTION_IDX_DESCRIPTION] = new TabItem('Description', descriptionImage);
	
	
	/* Tabs for Recent */
	var tabs_recent = [];
	
	tabs_recent[RECENT_IDX_UR_PHOTOS]      = new TabItem('On Your Photos',        recentPhotosImage);
	tabs_recent[RECENT_IDX_COMMENTS]       = new TabItem('On Your Comments',      recentCommentsImage);
	tabs_recent[RECENT_IDX_CONTACT_PHOTOS] = new TabItem('Contacts\' Photos',     recentContactsPhotosImage);
	tabs_recent[RECENT_IDX_CONTACTS] 	   = new TabItem('Contacts Who Uploaded', recentContactsImage);
	tabs_recent[RECENT_IDX_PUBLIC_PHOTOS]  = new TabItem('Public Photos',         recentPublicPhotosImage);
	
	
	/* Tabs for Explore */
	var tabs_explore = [];
	
	tabs_explore[EXPLORE_IDX_TODAY]   = new TabItem('Today\'s Interesting', exploreTodayImage);
	tabs_explore[EXPLORE_IDX_BY_DATE] = new TabItem('Interesting By Date',  exploreByDateImage);

	
	/* Tabs for Search */
	var tabs_search = [];
	
	tabs_search[SEARCH_IDX_NEAR_ME]         = new TabItem('Near Me',            searchNearMeImage);
	tabs_search[SEARCH_IDX_TEXT]            = new TabItem('Text',               searchTextImage);
	tabs_search[SEARCH_IDX_TAGS]            = new TabItem('Tags',               searchTagsImage);
	tabs_search[SEARCH_IDX_PERSON_EMAIL]    = new TabItem('Person By Email',    searchPersonEmailImage);
	tabs_search[SEARCH_IDX_PERSON_USERNAME] = new TabItem('Person By Username', searchPersonUsernameImage);
	tabs_search[SEARCH_IDX_PLACES]          = new TabItem('Places',             searchPlacesImage);

	/* Tabs for BookmarksMenu */
	var tabs_bookmarksmenu = [];
	
	tabs_bookmarksmenu[BOOKMARKSMENU_IDX_PHOTOS]   = new TabItem('Photos',   bookmarksPhotosImage);
	tabs_bookmarksmenu[BOOKMARKSMENU_IDX_CONTACTS] = new TabItem('Contacts', bookmarksContactsImage);
	tabs_bookmarksmenu[BOOKMARKSMENU_IDX_SETS]     = new TabItem('Sets',     bookmarksSetsImage);
	
	
	
	
	
	
	
	